/* Generated by wayland-scanner 1.22.0 */

/*
 * Copyright 2016 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

#ifndef __has_attribute
# define __has_attribute(x) 0  /* Compatibility with non-clang compilers. */
#endif

#if (__has_attribute(visibility) || defined(__GNUC__) && __GNUC__ >= 4)
#define WL_PRIVATE __attribute__ ((visibility("hidden")))
#else
#define WL_PRIVATE
#endif

extern const struct wl_interface wl_seat_interface;
extern const struct wl_interface zcr_gamepad_v2_interface;
extern const struct wl_interface zcr_gamepad_vibrator_v2_interface;
extern const struct wl_interface zcr_gaming_seat_v2_interface;

static const struct wl_interface *gaming_input_unstable_v2_types[] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&zcr_gaming_seat_v2_interface,
	&wl_seat_interface,
	&zcr_gamepad_v2_interface,
	&zcr_gamepad_v2_interface,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&zcr_gamepad_vibrator_v2_interface,
};

static const struct wl_message zcr_gaming_input_v2_requests[] = {
	{ "get_gaming_seat", "no", gaming_input_unstable_v2_types + 6 },
	{ "destroy", "", gaming_input_unstable_v2_types + 0 },
};

WL_PRIVATE const struct wl_interface zcr_gaming_input_v2_interface = {
	"zcr_gaming_input_v2", 2,
	2, zcr_gaming_input_v2_requests,
	0, NULL,
};

static const struct wl_message zcr_gaming_seat_v2_requests[] = {
	{ "destroy", "", gaming_input_unstable_v2_types + 0 },
};

static const struct wl_message zcr_gaming_seat_v2_events[] = {
	{ "gamepad_added", "n", gaming_input_unstable_v2_types + 8 },
	{ "gamepad_added_with_device_info", "nsuuuu", gaming_input_unstable_v2_types + 9 },
};

WL_PRIVATE const struct wl_interface zcr_gaming_seat_v2_interface = {
	"zcr_gaming_seat_v2", 1,
	1, zcr_gaming_seat_v2_requests,
	2, zcr_gaming_seat_v2_events,
};

static const struct wl_message zcr_gamepad_v2_requests[] = {
	{ "destroy", "", gaming_input_unstable_v2_types + 0 },
};

static const struct wl_message zcr_gamepad_v2_events[] = {
	{ "removed", "", gaming_input_unstable_v2_types + 0 },
	{ "axis", "uuf", gaming_input_unstable_v2_types + 0 },
	{ "button", "uuuf", gaming_input_unstable_v2_types + 0 },
	{ "frame", "u", gaming_input_unstable_v2_types + 0 },
	{ "axis_added", "uiiiii", gaming_input_unstable_v2_types + 0 },
	{ "activated", "", gaming_input_unstable_v2_types + 0 },
	{ "vibrator_added", "2n", gaming_input_unstable_v2_types + 15 },
};

WL_PRIVATE const struct wl_interface zcr_gamepad_v2_interface = {
	"zcr_gamepad_v2", 2,
	1, zcr_gamepad_v2_requests,
	7, zcr_gamepad_v2_events,
};

static const struct wl_message zcr_gamepad_vibrator_v2_requests[] = {
	{ "vibrate", "2aai", gaming_input_unstable_v2_types + 0 },
	{ "cancel_vibration", "2", gaming_input_unstable_v2_types + 0 },
	{ "destroy", "2", gaming_input_unstable_v2_types + 0 },
};

WL_PRIVATE const struct wl_interface zcr_gamepad_vibrator_v2_interface = {
	"zcr_gamepad_vibrator_v2", 2,
	3, zcr_gamepad_vibrator_v2_requests,
	0, NULL,
};

