/* Generated by wayland-scanner 1.22.0 */

#ifndef AURA_SHELL_SERVER_PROTOCOL_H
#define AURA_SHELL_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_aura_shell The aura_shell protocol
 * @section page_ifaces_aura_shell Interfaces
 * - @subpage page_iface_zaura_shell - aura_shell
 * - @subpage page_iface_zaura_surface - aura shell interface to a wl_surface
 * - @subpage page_iface_zaura_output - aura shell interface to a wl_output
 * - @subpage page_iface_zaura_toplevel - aura shell interface to the toplevel shell
 * - @subpage page_iface_zaura_popup - aura shell interface to the popup shell
 * @section page_copyright_aura_shell Copyright
 * <pre>
 *
 * Copyright 2017 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct wl_output;
struct wl_surface;
struct xdg_popup;
struct xdg_toplevel;
struct zaura_output;
struct zaura_popup;
struct zaura_shell;
struct zaura_surface;
struct zaura_toplevel;

#ifndef ZAURA_SHELL_INTERFACE
#define ZAURA_SHELL_INTERFACE
/**
 * @page page_iface_zaura_shell zaura_shell
 * @section page_iface_zaura_shell_desc Description
 *
 * The global interface exposing aura shell capabilities is used to
 * instantiate an interface extension for a wl_surface object.
 * This extended interface will then allow the client to use aura shell
 * specific functionality.
 * @section page_iface_zaura_shell_api API
 * See @ref iface_zaura_shell.
 */
/**
 * @defgroup iface_zaura_shell The zaura_shell interface
 *
 * The global interface exposing aura shell capabilities is used to
 * instantiate an interface extension for a wl_surface object.
 * This extended interface will then allow the client to use aura shell
 * specific functionality.
 */
extern const struct wl_interface zaura_shell_interface;
#endif
#ifndef ZAURA_SURFACE_INTERFACE
#define ZAURA_SURFACE_INTERFACE
/**
 * @page page_iface_zaura_surface zaura_surface
 * @section page_iface_zaura_surface_desc Description
 *
 * An additional interface to a wl_surface object, which allows the
 * client to access aura shell specific functionality for surface.
 * @section page_iface_zaura_surface_api API
 * See @ref iface_zaura_surface.
 */
/**
 * @defgroup iface_zaura_surface The zaura_surface interface
 *
 * An additional interface to a wl_surface object, which allows the
 * client to access aura shell specific functionality for surface.
 */
extern const struct wl_interface zaura_surface_interface;
#endif
#ifndef ZAURA_OUTPUT_INTERFACE
#define ZAURA_OUTPUT_INTERFACE
/**
 * @page page_iface_zaura_output zaura_output
 * @section page_iface_zaura_output_desc Description
 *
 * An additional interface to a wl_output object, which allows the
 * client to access aura shell specific functionality for output.
 * @section page_iface_zaura_output_api API
 * See @ref iface_zaura_output.
 */
/**
 * @defgroup iface_zaura_output The zaura_output interface
 *
 * An additional interface to a wl_output object, which allows the
 * client to access aura shell specific functionality for output.
 */
extern const struct wl_interface zaura_output_interface;
#endif
#ifndef ZAURA_TOPLEVEL_INTERFACE
#define ZAURA_TOPLEVEL_INTERFACE
/**
 * @page page_iface_zaura_toplevel zaura_toplevel
 * @section page_iface_zaura_toplevel_desc Description
 *
 * An interface to the toplevel shell, which allows the
 * client to access shell specific functionality.
 * @section page_iface_zaura_toplevel_api API
 * See @ref iface_zaura_toplevel.
 */
/**
 * @defgroup iface_zaura_toplevel The zaura_toplevel interface
 *
 * An interface to the toplevel shell, which allows the
 * client to access shell specific functionality.
 */
extern const struct wl_interface zaura_toplevel_interface;
#endif
#ifndef ZAURA_POPUP_INTERFACE
#define ZAURA_POPUP_INTERFACE
/**
 * @page page_iface_zaura_popup zaura_popup
 * @section page_iface_zaura_popup_desc Description
 *
 * An interface to the popup shell, which allows the
 * client to access shell specific functionality.
 * @section page_iface_zaura_popup_api API
 * See @ref iface_zaura_popup.
 */
/**
 * @defgroup iface_zaura_popup The zaura_popup interface
 *
 * An interface to the popup shell, which allows the
 * client to access shell specific functionality.
 */
extern const struct wl_interface zaura_popup_interface;
#endif

#ifndef ZAURA_SHELL_ERROR_ENUM
#define ZAURA_SHELL_ERROR_ENUM
enum zaura_shell_error {
	/**
	 * the surface already has an aura surface object associated
	 */
	ZAURA_SHELL_ERROR_AURA_SURFACE_EXISTS = 0,
	/**
	 * the output already has an aura output object associated
	 */
	ZAURA_SHELL_ERROR_AURA_OUTPUT_EXISTS = 1,
};
#endif /* ZAURA_SHELL_ERROR_ENUM */

#ifndef ZAURA_SHELL_LAYOUT_MODE_ENUM
#define ZAURA_SHELL_LAYOUT_MODE_ENUM
/**
 * @ingroup iface_zaura_shell
 * the layout mode
 *
 * Specifies the server's window layout mode.
 */
enum zaura_shell_layout_mode {
	/**
	 * multiple windows
	 */
	ZAURA_SHELL_LAYOUT_MODE_WINDOWED = 1,
	/**
	 * restricted mode for tablet
	 */
	ZAURA_SHELL_LAYOUT_MODE_TABLET = 2,
};
#endif /* ZAURA_SHELL_LAYOUT_MODE_ENUM */

/**
 * @ingroup iface_zaura_shell
 * @struct zaura_shell_interface
 */
struct zaura_shell_interface {
	/**
	 * extend surface interface for aura shell
	 *
	 * Instantiate an interface extension for the given wl_surface to
	 * provide aura shell functionality. If the given wl_surface is not
	 * associated with a shell surface, the shell_surface_missing
	 * protocol error is raised.
	 * @param id the new aura surface interface id
	 * @param surface the surface
	 */
	void (*get_aura_surface)(struct wl_client *client,
				 struct wl_resource *resource,
				 uint32_t id,
				 struct wl_resource *surface);
	/**
	 * extend output interface for aura shell
	 *
	 * Instantiate an interface extension for the given wl_output to
	 * provide aura shell functionality.
	 * @param id the new aura output interface id
	 * @param output the output
	 * @since 2
	 */
	void (*get_aura_output)(struct wl_client *client,
				struct wl_resource *resource,
				uint32_t id,
				struct wl_resource *output);
	/**
	 * surfaces will be submitted in pixel coordinates
	 *
	 * [Deprecated] Informs the server that when submitting surfaces,
	 * this client will not use wl_surface_set_buffer_scale to report
	 * the scales, nor will it apply scale via vp_viewporter. Instead
	 * the server should apply an appropriate scale transform to have
	 * the submitted buffers composited correctly.
	 * @since 26
	 */
	void (*surface_submission_in_pixel_coordinates)(struct wl_client *client,
							struct wl_resource *resource);
	/**
	 * get aura toplevel
	 *
	 * Retrieve the aura toplevel interface for a given xdg toplevel
	 * interface
	 * @param id the new aura toplevel interface id
	 * @since 27
	 */
	void (*get_aura_toplevel_for_xdg_toplevel)(struct wl_client *client,
						   struct wl_resource *resource,
						   uint32_t id,
						   struct wl_resource *toplevel);
	/**
	 * get aura popup
	 *
	 * Retrieve the aura popup interface for the given xdg popup
	 * interface
	 * @param id the aura popup interface id
	 * @since 28
	 */
	void (*get_aura_popup_for_xdg_popup)(struct wl_client *client,
					     struct wl_resource *resource,
					     uint32_t id,
					     struct wl_resource *popup);
	/**
	 * release zaura_shell object
	 *
	 * Using this request a client can tell the server that it is not
	 * going to use the zaura_shell object anymore. This does not
	 * affect any other objects.
	 *
	 * This is named "release" because "destroy" is a special named
	 * function used for freeing wl_proxy objects. Naming it "destroy"
	 * will cause marshalling errors when running on lower versioned
	 * hosts. All "release" requests here should be renamed to
	 * "destroy" if we move to aura-shell v2.
	 * @since 38
	 */
	void (*release)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZAURA_SHELL_LAYOUT_MODE 0
#define ZAURA_SHELL_BUG_FIX 1
#define ZAURA_SHELL_DESKS_CHANGED 2
#define ZAURA_SHELL_DESK_ACTIVATION_CHANGED 3
#define ZAURA_SHELL_ACTIVATED 4

/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_LAYOUT_MODE_SINCE_VERSION 11
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_BUG_FIX_SINCE_VERSION 14
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_DESKS_CHANGED_SINCE_VERSION 22
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_DESK_ACTIVATION_CHANGED_SINCE_VERSION 22
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_ACTIVATED_SINCE_VERSION 24

/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_GET_AURA_SURFACE_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_GET_AURA_OUTPUT_SINCE_VERSION 2
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES_SINCE_VERSION 26
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_GET_AURA_TOPLEVEL_FOR_XDG_TOPLEVEL_SINCE_VERSION 27
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_GET_AURA_POPUP_FOR_XDG_POPUP_SINCE_VERSION 28
/**
 * @ingroup iface_zaura_shell
 */
#define ZAURA_SHELL_RELEASE_SINCE_VERSION 38

/**
 * @ingroup iface_zaura_shell
 * Sends an layout_mode event to the client owning the resource.
 * @param resource_ The client's resource
 * @param layout_mode layout_mode enum
 */
static inline void
zaura_shell_send_layout_mode(struct wl_resource *resource_, uint32_t layout_mode)
{
	wl_resource_post_event(resource_, ZAURA_SHELL_LAYOUT_MODE, layout_mode);
}

/**
 * @ingroup iface_zaura_shell
 * Sends an bug_fix event to the client owning the resource.
 * @param resource_ The client's resource
 * @param id ID of a single bug fix
 */
static inline void
zaura_shell_send_bug_fix(struct wl_resource *resource_, uint32_t id)
{
	wl_resource_post_event(resource_, ZAURA_SHELL_BUG_FIX, id);
}

/**
 * @ingroup iface_zaura_shell
 * Sends an desks_changed event to the client owning the resource.
 * @param resource_ The client's resource
 * @param desk_names an array of existing desks' names
 */
static inline void
zaura_shell_send_desks_changed(struct wl_resource *resource_, struct wl_array *desk_names)
{
	wl_resource_post_event(resource_, ZAURA_SHELL_DESKS_CHANGED, desk_names);
}

/**
 * @ingroup iface_zaura_shell
 * Sends an desk_activation_changed event to the client owning the resource.
 * @param resource_ The client's resource
 * @param active_desk_index index of the active desk
 */
static inline void
zaura_shell_send_desk_activation_changed(struct wl_resource *resource_, int32_t active_desk_index)
{
	wl_resource_post_event(resource_, ZAURA_SHELL_DESK_ACTIVATION_CHANGED, active_desk_index);
}

/**
 * @ingroup iface_zaura_shell
 * Sends an activated event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_shell_send_activated(struct wl_resource *resource_, struct wl_resource *gained_active, struct wl_resource *lost_active)
{
	wl_resource_post_event(resource_, ZAURA_SHELL_ACTIVATED, gained_active, lost_active);
}

#ifndef ZAURA_SURFACE_FRAME_TYPE_ENUM
#define ZAURA_SURFACE_FRAME_TYPE_ENUM
/**
 * @ingroup iface_zaura_surface
 * different frame types
 *
 * Frame types that can be used to decorate a surface.
 */
enum zaura_surface_frame_type {
	/**
	 * no frame
	 */
	ZAURA_SURFACE_FRAME_TYPE_NONE = 0,
	/**
	 * caption with shadow
	 */
	ZAURA_SURFACE_FRAME_TYPE_NORMAL = 1,
	/**
	 * shadow only
	 */
	ZAURA_SURFACE_FRAME_TYPE_SHADOW = 2,
};
#endif /* ZAURA_SURFACE_FRAME_TYPE_ENUM */

#ifndef ZAURA_SURFACE_OCCLUSION_CHANGE_REASON_ENUM
#define ZAURA_SURFACE_OCCLUSION_CHANGE_REASON_ENUM
/**
 * @ingroup iface_zaura_surface
 * occlusion change reason
 *
 * Enum describing why an occlusion change happened. An occlusion change as a
 * result of a user action could include things like the user moving a window,
 * changing occlusion, or opening/closing a window, changing the occlusion.
 */
enum zaura_surface_occlusion_change_reason {
	/**
	 * occlusion changed as a result of a user action
	 */
	ZAURA_SURFACE_OCCLUSION_CHANGE_REASON_USER_ACTION = 1,
};
#endif /* ZAURA_SURFACE_OCCLUSION_CHANGE_REASON_ENUM */

#ifndef ZAURA_SURFACE_FULLSCREEN_MODE_ENUM
#define ZAURA_SURFACE_FULLSCREEN_MODE_ENUM
/**
 * @ingroup iface_zaura_surface
 * Specifies the behavior of the surface in fullscreen.
 *
 * Possible windowing system behaviors if this surface were to go
 * fullscreen.
 */
enum zaura_surface_fullscreen_mode {
	/**
	 * user can access system UIs such as the shelf and window frame           by pointing to, or swiping over, the screen edge
	 */
	ZAURA_SURFACE_FULLSCREEN_MODE_IMMERSIVE = 0,
	/**
	 * user cannot access system UIs using mouse/touches
	 */
	ZAURA_SURFACE_FULLSCREEN_MODE_PLAIN = 1,
};
#endif /* ZAURA_SURFACE_FULLSCREEN_MODE_ENUM */

#ifndef ZAURA_SURFACE_SNAP_DIRECTION_ENUM
#define ZAURA_SURFACE_SNAP_DIRECTION_ENUM
/**
 * @ingroup iface_zaura_surface
 * surface snap directions
 *
 * Surface snap directions.
 */
enum zaura_surface_snap_direction {
	/**
	 * 
	 */
	ZAURA_SURFACE_SNAP_DIRECTION_NONE = 0,
	/**
	 * 
	 */
	ZAURA_SURFACE_SNAP_DIRECTION_LEFT = 1,
	/**
	 * 
	 */
	ZAURA_SURFACE_SNAP_DIRECTION_RIGHT = 2,
};
#endif /* ZAURA_SURFACE_SNAP_DIRECTION_ENUM */

#ifndef ZAURA_SURFACE_OCCLUSION_STATE_ENUM
#define ZAURA_SURFACE_OCCLUSION_STATE_ENUM
/**
 * @ingroup iface_zaura_surface
 * surface occlusion state
 *
 * Describes the occlusion state of a surface.
 */
enum zaura_surface_occlusion_state {
	/**
	 * The surface's occlusion state isn't tracked
	 */
	ZAURA_SURFACE_OCCLUSION_STATE_UNKNOWN = 0,
	/**
	 * The surface is visible
	 */
	ZAURA_SURFACE_OCCLUSION_STATE_VISIBLE = 1,
	/**
	 * The surface is occluded
	 */
	ZAURA_SURFACE_OCCLUSION_STATE_OCCLUDED = 2,
	/**
	 * The surface is not visible
	 */
	ZAURA_SURFACE_OCCLUSION_STATE_HIDDEN = 3,
};
#endif /* ZAURA_SURFACE_OCCLUSION_STATE_ENUM */

/**
 * @ingroup iface_zaura_surface
 * @struct zaura_surface_interface
 */
struct zaura_surface_interface {
	/**
	 * request a frame for surface
	 *
	 * [Deprecated] Suggests a surface should use a specific frame.
	 * Deprecated since M105. See the set_decoration method on
	 * zaura_toplevel and zaura_popup.
	 * @param type the new frame type
	 */
	void (*set_frame)(struct wl_client *client,
			  struct wl_resource *resource,
			  uint32_t type);
	/**
	 * set the parent of this surface
	 *
	 * Set the "parent" of this surface. "x" and "y" arguments
	 * specify the initial position for surface relative to parent.
	 * @since 2
	 */
	void (*set_parent)(struct wl_client *client,
			   struct wl_resource *resource,
			   struct wl_resource *parent,
			   int32_t x,
			   int32_t y);
	/**
	 * set the frame colors of this surface
	 *
	 * Set the frame colors.
	 * @param active_color 32 bit ARGB color value, not premultiplied
	 * @param inactive_color 32 bit ARGB color value, not premultiplied
	 * @since 3
	 */
	void (*set_frame_colors)(struct wl_client *client,
				 struct wl_resource *resource,
				 uint32_t active_color,
				 uint32_t inactive_color);
	/**
	 * set the startup ID of this surface
	 *
	 * Set the startup ID.
	 * @since 4
	 */
	void (*set_startup_id)(struct wl_client *client,
			       struct wl_resource *resource,
			       const char *startup_id);
	/**
	 * set the application ID of this surface
	 *
	 * Set the application ID.
	 * @since 5
	 */
	void (*set_application_id)(struct wl_client *client,
				   struct wl_resource *resource,
				   const char *application_id);
	/**
	 * set the client surface ID of this surface
	 *
	 * Deprecated. Please use set_client_surface_str_id instead. Set
	 * the identifier of the surface assigned by the client.
	 * @since 7
	 */
	void (*set_client_surface_id)(struct wl_client *client,
				      struct wl_resource *resource,
				      int32_t client_surface_id);
	/**
	 * set tracked occlusion region
	 *
	 * Sets occlusion tracking on this surface. The client will be
	 * updated with a new occlusion fraction when the amount of
	 * occlusion of this surface changes.
	 * @since 8
	 */
	void (*set_occlusion_tracking)(struct wl_client *client,
				       struct wl_resource *resource);
	/**
	 * unset tracked occlusion region
	 *
	 * Unsets occlusion tracking for this surface.
	 * @since 8
	 */
	void (*unset_occlusion_tracking)(struct wl_client *client,
					 struct wl_resource *resource);
	/**
	 * Indicate that this window wants to be the active window
	 *
	 * Make this the active window. This usually implies something
	 * like restacking this surface to the foreground. The compositor
	 * is free to ignore this request if it deems the client to be
	 * misbehaving. Typically this request will only be honoured in
	 * response to some user driven event, such as executing an
	 * application or opening a file in a window that already exists.
	 * @since 9
	 */
	void (*activate)(struct wl_client *client,
			 struct wl_resource *resource);
	/**
	 * Indicate that this window wants some of the user's attention
	 *
	 * Draw attention to this surface in a way that does not change
	 * the user's focus. This usually means animating window
	 * decorations or taskbar icons. The compositor can still ignore
	 * this request if it deems fit, but unlike draw_focus, these
	 * requests are expected to come from background tasks, and are
	 * more likely to be honoured.
	 * @since 9
	 */
	void (*draw_attention)(struct wl_client *client,
			       struct wl_resource *resource);
	/**
	 * Sets the behavior of the surface in fullscreen.
	 *
	 * Suggests how the windowing system should behave if this
	 * surface were to go fullscreen. Does not make the surface
	 * fullscreen.
	 *
	 * Typically the default mode is "immersive".
	 * @since 10
	 */
	void (*set_fullscreen_mode)(struct wl_client *client,
				    struct wl_resource *resource,
				    uint32_t mode);
	/**
	 * set the client surface ID of this surface
	 *
	 * Set the identifier of the surface assigned by the client.
	 * @since 12
	 */
	void (*set_client_surface_str_id)(struct wl_client *client,
					  struct wl_resource *resource,
					  const char *client_surface_id);
	/**
	 * request a server-side shadow for surface
	 *
	 * Suggests a surface to have client-side decoration, but
	 * server-side decides when and where to start the resize. The
	 * server may also apply visual effects to indicate that the resize
	 * operation is ongoing.
	 * @since 15
	 */
	void (*set_server_start_resize)(struct wl_client *client,
					struct wl_resource *resource);
	/**
	 * client intents to snap the surface.
	 *
	 * Notify (or inform) the server the client's intent to snap the
	 * window. To inform it's no longer willing to snap, send 'none'.
	 * @since 16
	 */
	void (*intent_to_snap)(struct wl_client *client,
			       struct wl_resource *resource,
			       uint32_t direction);
	/**
	 * snap the surface to the left.
	 *
	 * Request that surface is snapped to the left.
	 * @since 16
	 */
	void (*set_snap_left)(struct wl_client *client,
			      struct wl_resource *resource);
	/**
	 * snap the surface to the right.
	 *
	 * Request that surface is snapped to the right.
	 * @since 16
	 */
	void (*set_snap_right)(struct wl_client *client,
			       struct wl_resource *resource);
	/**
	 * Unset the surface snap.
	 *
	 * Request that surface resets snapping.
	 * @since 16
	 */
	void (*unset_snap)(struct wl_client *client,
			   struct wl_resource *resource);
	/**
	 * set surface window session id
	 *
	 * Set window session id to the surface.
	 * @param id window session id
	 * @since 18
	 */
	void (*set_window_session_id)(struct wl_client *client,
				      struct wl_resource *resource,
				      int32_t id);
	/**
	 * Set the minimize-on-back-gesture behavior.
	 *
	 * Sets that the surface can go back as per its navigation list.
	 * This allows the server to react to by minimizing the window upon
	 * a system wide back gesture.
	 * @since 19
	 */
	void (*set_can_go_back)(struct wl_client *client,
				struct wl_resource *resource);
	/**
	 * Unset the minimize-on-back-gesture behavior.
	 *
	 * Unsets that the surface can go back as per its navigation
	 * list. See above.
	 * @since 19
	 */
	void (*unset_can_go_back)(struct wl_client *client,
				  struct wl_resource *resource);
	/**
	 * Set pip for the surface.
	 *
	 * Requests that the surface is set to Picture-in-Picture (PIP).
	 * @since 20
	 */
	void (*set_pip)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * Unset pip for the surface.
	 *
	 * Requests that the surface is unset from Picture-in-Picture
	 * (PIP).
	 * @since 20
	 */
	void (*unset_pip)(struct wl_client *client,
			  struct wl_resource *resource);
	/**
	 * Set aspect ratio for the surface.
	 *
	 * Sets the aspect ratio of the surface.
	 * @since 20
	 */
	void (*set_aspect_ratio)(struct wl_client *client,
				 struct wl_resource *resource,
				 int32_t width,
				 int32_t height);
	/**
	 * move to desk
	 *
	 * If |index| equals -1, requests that the server toggles whether
	 * client is visible on all workspaces. If |index| is not -1,
	 * requests that the server moves the client to the desk at
	 * |index|.
	 * @since 22
	 */
	void (*move_to_desk)(struct wl_client *client,
			     struct wl_resource *resource,
			     int32_t index);
	/**
	 * initial workspace for restore
	 *
	 * If |initial_workspace| equals '-1', a window is restored and
	 * visible on all workspaces, Otherwise, set the initial workspace
	 * to restore the window to the corresponding workspace. This is
	 * not double buffered and must be set before attaching a buffer.
	 * @param initial_workspace intial workspace for restoring or '-1' for visible on all workspaces
	 * @since 23
	 */
	void (*set_initial_workspace)(struct wl_client *client,
				      struct wl_resource *resource,
				      const char *initial_workspace);
	/**
	 * pin a window (trusted or not)
	 *
	 * Requests that a window is pinned which means that the system
	 * does not allow the user to leave the window until an exit
	 * criteria is met.
	 *
	 * This is a request to get the window pinned so that the user
	 * cannot get to any other window / application. There are two
	 * modes: A. trusted is 0 - which is slightly less restrictive and
	 * allows the user to get out of the window by a predefined way of
	 * authentication. B. trusted is not 0 in which case a trusted
	 * application was locking down the system and needs to unlock.
	 * This is used for e.g. School tests.
	 * @param trusted 0 for non trusted
	 * @since 25
	 */
	void (*set_pin)(struct wl_client *client,
			struct wl_resource *resource,
			int32_t trusted);
	/**
	 * unpin a window
	 *
	 * Requests that the user can leave a previously pinned window.
	 *
	 * This is a request to unpin a previously pinned window. It does
	 * not matter if the window was locked with the trusted state or
	 * not.
	 * @since 25
	 */
	void (*unset_pin)(struct wl_client *client,
			  struct wl_resource *resource);
	/**
	 * destroy zaura_surface
	 *
	 * Destroy the zaura_surface object. A client should destroy this
	 * object when the role is unmapped from a wl_surface.
	 *
	 * See zaura_shell.release for destructor naming.
	 * @since 38
	 */
	void (*release)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZAURA_SURFACE_OCCLUSION_CHANGED 0
#define ZAURA_SURFACE_LOCK_FRAME_NORMAL 1
#define ZAURA_SURFACE_UNLOCK_FRAME_NORMAL 2
#define ZAURA_SURFACE_OCCLUSION_STATE_CHANGED 3
#define ZAURA_SURFACE_DESK_CHANGED 4
#define ZAURA_SURFACE_START_THROTTLE 5
#define ZAURA_SURFACE_END_THROTTLE 6

/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_OCCLUSION_CHANGED_SINCE_VERSION 8
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_LOCK_FRAME_NORMAL_SINCE_VERSION 17
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNLOCK_FRAME_NORMAL_SINCE_VERSION 17
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_OCCLUSION_STATE_CHANGED_SINCE_VERSION 21
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_DESK_CHANGED_SINCE_VERSION 22
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_START_THROTTLE_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_END_THROTTLE_SINCE_VERSION 29

/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_FRAME_SINCE_VERSION 1
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_PARENT_SINCE_VERSION 2
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_FRAME_COLORS_SINCE_VERSION 3
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_STARTUP_ID_SINCE_VERSION 4
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_APPLICATION_ID_SINCE_VERSION 5
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_CLIENT_SURFACE_ID_SINCE_VERSION 7
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_OCCLUSION_TRACKING_SINCE_VERSION 8
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_OCCLUSION_TRACKING_SINCE_VERSION 8
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_ACTIVATE_SINCE_VERSION 9
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_DRAW_ATTENTION_SINCE_VERSION 9
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_FULLSCREEN_MODE_SINCE_VERSION 10
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_CLIENT_SURFACE_STR_ID_SINCE_VERSION 12
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_SERVER_START_RESIZE_SINCE_VERSION 15
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_INTENT_TO_SNAP_SINCE_VERSION 16
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_SNAP_LEFT_SINCE_VERSION 16
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_SNAP_RIGHT_SINCE_VERSION 16
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_SNAP_SINCE_VERSION 16
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_WINDOW_SESSION_ID_SINCE_VERSION 18
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_CAN_GO_BACK_SINCE_VERSION 19
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_CAN_GO_BACK_SINCE_VERSION 19
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_PIP_SINCE_VERSION 20
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_PIP_SINCE_VERSION 20
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_ASPECT_RATIO_SINCE_VERSION 20
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_MOVE_TO_DESK_SINCE_VERSION 22
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_INITIAL_WORKSPACE_SINCE_VERSION 23
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_SET_PIN_SINCE_VERSION 25
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_UNSET_PIN_SINCE_VERSION 25
/**
 * @ingroup iface_zaura_surface
 */
#define ZAURA_SURFACE_RELEASE_SINCE_VERSION 38

/**
 * @ingroup iface_zaura_surface
 * Sends an occlusion_changed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_surface_send_occlusion_changed(struct wl_resource *resource_, wl_fixed_t occlusion_fraction, uint32_t occlusion_reason)
{
	wl_resource_post_event(resource_, ZAURA_SURFACE_OCCLUSION_CHANGED, occlusion_fraction, occlusion_reason);
}

/**
 * @ingroup iface_zaura_surface
 * Sends an lock_frame_normal event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_surface_send_lock_frame_normal(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZAURA_SURFACE_LOCK_FRAME_NORMAL);
}

/**
 * @ingroup iface_zaura_surface
 * Sends an unlock_frame_normal event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_surface_send_unlock_frame_normal(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZAURA_SURFACE_UNLOCK_FRAME_NORMAL);
}

/**
 * @ingroup iface_zaura_surface
 * Sends an occlusion_state_changed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_surface_send_occlusion_state_changed(struct wl_resource *resource_, uint32_t mode)
{
	wl_resource_post_event(resource_, ZAURA_SURFACE_OCCLUSION_STATE_CHANGED, mode);
}

/**
 * @ingroup iface_zaura_surface
 * Sends an desk_changed event to the client owning the resource.
 * @param resource_ The client's resource
 * @param state index of desk or -1 for a window assigned to all desks
 */
static inline void
zaura_surface_send_desk_changed(struct wl_resource *resource_, int32_t state)
{
	wl_resource_post_event(resource_, ZAURA_SURFACE_DESK_CHANGED, state);
}

/**
 * @ingroup iface_zaura_surface
 * Sends an start_throttle event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_surface_send_start_throttle(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZAURA_SURFACE_START_THROTTLE);
}

/**
 * @ingroup iface_zaura_surface
 * Sends an end_throttle event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_surface_send_end_throttle(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZAURA_SURFACE_END_THROTTLE);
}

#ifndef ZAURA_OUTPUT_SCALE_PROPERTY_ENUM
#define ZAURA_OUTPUT_SCALE_PROPERTY_ENUM
/**
 * @ingroup iface_zaura_output
 * scale information
 *
 * These flags describe properties of an output scale.
 * They are used in the flags bitfield of the scale event.
 */
enum zaura_output_scale_property {
	/**
	 * indicates this is the current scale
	 */
	ZAURA_OUTPUT_SCALE_PROPERTY_CURRENT = 0x1,
	/**
	 * indicates this is the preferred scale
	 */
	ZAURA_OUTPUT_SCALE_PROPERTY_PREFERRED = 0x2,
};
#endif /* ZAURA_OUTPUT_SCALE_PROPERTY_ENUM */

#ifndef ZAURA_OUTPUT_SCALE_FACTOR_ENUM
#define ZAURA_OUTPUT_SCALE_FACTOR_ENUM
enum zaura_output_scale_factor {
	ZAURA_OUTPUT_SCALE_FACTOR_0400 = 400,
	ZAURA_OUTPUT_SCALE_FACTOR_0500 = 500,
	ZAURA_OUTPUT_SCALE_FACTOR_0550 = 550,
	ZAURA_OUTPUT_SCALE_FACTOR_0600 = 600,
	ZAURA_OUTPUT_SCALE_FACTOR_0625 = 625,
	ZAURA_OUTPUT_SCALE_FACTOR_0650 = 650,
	ZAURA_OUTPUT_SCALE_FACTOR_0700 = 700,
	ZAURA_OUTPUT_SCALE_FACTOR_0750 = 750,
	ZAURA_OUTPUT_SCALE_FACTOR_0800 = 800,
	ZAURA_OUTPUT_SCALE_FACTOR_0850 = 850,
	ZAURA_OUTPUT_SCALE_FACTOR_0900 = 900,
	ZAURA_OUTPUT_SCALE_FACTOR_0950 = 950,
	ZAURA_OUTPUT_SCALE_FACTOR_1000 = 1000,
	ZAURA_OUTPUT_SCALE_FACTOR_1050 = 1050,
	ZAURA_OUTPUT_SCALE_FACTOR_1100 = 1100,
	ZAURA_OUTPUT_SCALE_FACTOR_1150 = 1150,
	ZAURA_OUTPUT_SCALE_FACTOR_1125 = 1125,
	ZAURA_OUTPUT_SCALE_FACTOR_1200 = 1200,
	ZAURA_OUTPUT_SCALE_FACTOR_1250 = 1250,
	ZAURA_OUTPUT_SCALE_FACTOR_1300 = 1300,
	ZAURA_OUTPUT_SCALE_FACTOR_1400 = 1400,
	ZAURA_OUTPUT_SCALE_FACTOR_1450 = 1450,
	ZAURA_OUTPUT_SCALE_FACTOR_1500 = 1500,
	ZAURA_OUTPUT_SCALE_FACTOR_1600 = 1600,
	ZAURA_OUTPUT_SCALE_FACTOR_1750 = 1750,
	ZAURA_OUTPUT_SCALE_FACTOR_1800 = 1800,
	ZAURA_OUTPUT_SCALE_FACTOR_2000 = 2000,
	ZAURA_OUTPUT_SCALE_FACTOR_2200 = 2200,
	ZAURA_OUTPUT_SCALE_FACTOR_2250 = 2250,
	ZAURA_OUTPUT_SCALE_FACTOR_2500 = 2500,
	ZAURA_OUTPUT_SCALE_FACTOR_2750 = 2750,
	ZAURA_OUTPUT_SCALE_FACTOR_3000 = 3000,
	ZAURA_OUTPUT_SCALE_FACTOR_3500 = 3500,
	ZAURA_OUTPUT_SCALE_FACTOR_4000 = 4000,
	ZAURA_OUTPUT_SCALE_FACTOR_4500 = 4500,
	ZAURA_OUTPUT_SCALE_FACTOR_5000 = 5000,
};
#endif /* ZAURA_OUTPUT_SCALE_FACTOR_ENUM */

#ifndef ZAURA_OUTPUT_CONNECTION_TYPE_ENUM
#define ZAURA_OUTPUT_CONNECTION_TYPE_ENUM
enum zaura_output_connection_type {
	ZAURA_OUTPUT_CONNECTION_TYPE_UNKNOWN = 0,
	ZAURA_OUTPUT_CONNECTION_TYPE_INTERNAL = 1,
};
#endif /* ZAURA_OUTPUT_CONNECTION_TYPE_ENUM */

/**
 * @ingroup iface_zaura_output
 * @struct zaura_output_interface
 */
struct zaura_output_interface {
	/**
	 * destroy zaura_output
	 *
	 * Destroy this zaura_shell object.
	 *
	 * Destroying a bound zaura_shell object while there are
	 * zaura_surfaces still alive created by this zaura_shell object
	 * instance is illegal and will result in a protocol error.
	 *
	 * See zaura_shell.release for destructor naming.
	 * @since 38
	 */
	void (*release)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZAURA_OUTPUT_SCALE 0
#define ZAURA_OUTPUT_CONNECTION 1
#define ZAURA_OUTPUT_DEVICE_SCALE_FACTOR 2
#define ZAURA_OUTPUT_INSETS 3
#define ZAURA_OUTPUT_LOGICAL_TRANSFORM 4

/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_SCALE_SINCE_VERSION 2
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_CONNECTION_SINCE_VERSION 5
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_DEVICE_SCALE_FACTOR_SINCE_VERSION 5
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_INSETS_SINCE_VERSION 33
/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_LOGICAL_TRANSFORM_SINCE_VERSION 34

/**
 * @ingroup iface_zaura_output
 */
#define ZAURA_OUTPUT_RELEASE_SINCE_VERSION 38

/**
 * @ingroup iface_zaura_output
 * Sends an scale event to the client owning the resource.
 * @param resource_ The client's resource
 * @param flags bitfield of scale flags
 * @param scale output scale
 */
static inline void
zaura_output_send_scale(struct wl_resource *resource_, uint32_t flags, uint32_t scale)
{
	wl_resource_post_event(resource_, ZAURA_OUTPUT_SCALE, flags, scale);
}

/**
 * @ingroup iface_zaura_output
 * Sends an connection event to the client owning the resource.
 * @param resource_ The client's resource
 * @param connection output connection
 */
static inline void
zaura_output_send_connection(struct wl_resource *resource_, uint32_t connection)
{
	wl_resource_post_event(resource_, ZAURA_OUTPUT_CONNECTION, connection);
}

/**
 * @ingroup iface_zaura_output
 * Sends an device_scale_factor event to the client owning the resource.
 * @param resource_ The client's resource
 * @param scale output device scale factor
 */
static inline void
zaura_output_send_device_scale_factor(struct wl_resource *resource_, uint32_t scale)
{
	wl_resource_post_event(resource_, ZAURA_OUTPUT_DEVICE_SCALE_FACTOR, scale);
}

/**
 * @ingroup iface_zaura_output
 * Sends an insets event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_output_send_insets(struct wl_resource *resource_, int32_t top, int32_t left, int32_t bottom, int32_t right)
{
	wl_resource_post_event(resource_, ZAURA_OUTPUT_INSETS, top, left, bottom, right);
}

/**
 * @ingroup iface_zaura_output
 * Sends an logical_transform event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_output_send_logical_transform(struct wl_resource *resource_, int32_t transform)
{
	wl_resource_post_event(resource_, ZAURA_OUTPUT_LOGICAL_TRANSFORM, transform);
}

#ifndef ZAURA_TOPLEVEL_ORIENTATION_LOCK_ENUM
#define ZAURA_TOPLEVEL_ORIENTATION_LOCK_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * orientation lock request
 *
 * Defines orientation request when a surface is in fullscreen.
 */
enum zaura_toplevel_orientation_lock {
	/**
	 * no orientation lock
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_NONE = 1,
	/**
	 * primary or secondary portrait
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_PORTRAIT = 2,
	/**
	 * primary or secondary landscape
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_LANDSCAPE = 3,
	/**
	 * keep current orientation
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_CURRENT = 4,
	/**
	 * primary portrait
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_PORTRAIT_PRIMARY = 5,
	/**
	 * primary landscape
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_LANDSCAPE_PRIMARY = 6,
	/**
	 * secondary portrait
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_PORTRAIT_SECONDARY = 7,
	/**
	 * secondary landscape
	 */
	ZAURA_TOPLEVEL_ORIENTATION_LOCK_LANDSCAPE_SECONDARY = 8,
};
#endif /* ZAURA_TOPLEVEL_ORIENTATION_LOCK_ENUM */

#ifndef ZAURA_TOPLEVEL_STATE_ENUM
#define ZAURA_TOPLEVEL_STATE_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * supplemental aura states to xdg states
 *
 * The states that are contained here are supplemental to the states
 * defined in the XDG shell and specific aura windows.
 */
enum zaura_toplevel_state {
	/**
	 * immersive mode with hidden title bar and shelf
	 *
	 * User can access system UIs such as the shelf and window frame
	 * by pointing to, or swiping over, the screen edge.
	 * @since 36
	 */
	ZAURA_TOPLEVEL_STATE_IMMERSIVE = 100,
	/**
	 * surface is minized
	 *
	 * The window has been minimized.
	 * @since 36
	 */
	ZAURA_TOPLEVEL_STATE_MINIMIZED = 101,
};
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_IMMERSIVE_SINCE_VERSION 36
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_STATE_MINIMIZED_SINCE_VERSION 36
#endif /* ZAURA_TOPLEVEL_STATE_ENUM */

#ifndef ZAURA_TOPLEVEL_DECORATION_TYPE_ENUM
#define ZAURA_TOPLEVEL_DECORATION_TYPE_ENUM
/**
 * @ingroup iface_zaura_toplevel
 * different decoration types
 *
 * Decoration types are used to modify the surface (e.g. drop shadow).
 */
enum zaura_toplevel_decoration_type {
	/**
	 * no frame
	 */
	ZAURA_TOPLEVEL_DECORATION_TYPE_NONE = 0,
	/**
	 * caption with shadow
	 */
	ZAURA_TOPLEVEL_DECORATION_TYPE_NORMAL = 1,
	/**
	 * shadow only
	 */
	ZAURA_TOPLEVEL_DECORATION_TYPE_SHADOW = 2,
};
#endif /* ZAURA_TOPLEVEL_DECORATION_TYPE_ENUM */

/**
 * @ingroup iface_zaura_toplevel
 * @struct zaura_toplevel_interface
 */
struct zaura_toplevel_interface {
	/**
	 * set orientation lock for a remote surface
	 *
	 * Request a specific orientation behavior when this surface is
	 * in fullscreen.
	 * @since 26
	 */
	void (*set_orientation_lock)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t orientation_lock);
	/**
	 * surface will be submitted in pixel coordinates
	 *
	 * Informs the server that when submitting this surface, this
	 * client will not use wl_surface_set_buffer_scale to report the
	 * scales, nor will it apply scale via vp_viewporter. Instead the
	 * server should apply an appropriate scale transform for the
	 * submitted buffers to be composited correctly.
	 * @since 28
	 */
	void (*surface_submission_in_pixel_coordinates)(struct wl_client *client,
							struct wl_resource *resource);
	/**
	 * enables screen coordinates in window bounds
	 *
	 * Requesting this will enable screen coordinates in surfaces
	 * associated with aura_toplevel including sub surfaces and popup
	 * windows who added this toplevel as a parent. This should be set
	 * before first commit.
	 * @since 29
	 */
	void (*set_supports_screen_coordinates)(struct wl_client *client,
						struct wl_resource *resource);
	/**
	 * set window size and position
	 *
	 * Request a new location and bounds of the surface in DP screen
	 * coordinates. The size will be applied to visible bounds used in
	 * set_geometry. The output is a hint for the compositor to
	 * determine which output the window should move to. These
	 * parameters are just a request and the compositor may ignore,
	 * adjust the size and position based on the rule imposed by the
	 * window manager, or may preserve it for future operations. For
	 * example, the compositor will not allow a position outside of the
	 * output, or the compositor may just store it if the toplevel
	 * surface is in maximiezd state, and may use it upon unmaximized.
	 * @param output the output
	 * @since 29
	 */
	void (*set_window_bounds)(struct wl_client *client,
				  struct wl_resource *resource,
				  int32_t x,
				  int32_t y,
				  int32_t width,
				  int32_t height,
				  struct wl_resource *output);
	/**
	 * set session id and restore id
	 *
	 * Request session id and restore id of a newly created browser
	 * window. Set the information used by compositor to restore the
	 * toplevel surface state, such as window position, window state,
	 * upon creation. This is not double buffered and must be set
	 * before sending first commit.
	 * @param restore_session_id unique browser session id
	 * @param restore_window_id restore browser window id
	 * @since 30
	 */
	void (*set_restore_info)(struct wl_client *client,
				 struct wl_resource *resource,
				 int32_t restore_session_id,
				 int32_t restore_window_id);
	/**
	 * make window a system modal
	 *
	 * Requests that the toplevel surface should become a system
	 * modal. The compositor will prevent other windows from receiving
	 * events. If there are multiple system modal surfaces, the
	 * compositor will decide which one to receive events.
	 * @since 31
	 */
	void (*set_system_modal)(struct wl_client *client,
				 struct wl_resource *resource);
	/**
	 * unset window system modal state
	 *
	 * Requests that the system modal state of the toplevel surface
	 * will be unset. The compositor will then allow other windows to
	 * recieve events.
	 * @since 31
	 */
	void (*unset_system_modal)(struct wl_client *client,
				   struct wl_resource *resource);
	/**
	 * set session id and restore window id source
	 *
	 * Request session id and restore id of the window. Set the
	 * information used by compositor to restore the toplevel surface
	 * state, such as window position, window state, upon creation.
	 * This is not double buffered and must be set before sending first
	 * commit. This is different from set_restore_info, used for
	 * clients that create multiple windows associated with
	 * restore_id_source.
	 * @param restore_session_id unique browser session id
	 * @param restore_window_id_source restore window id source
	 * @since 32
	 */
	void (*set_restore_info_with_window_id_source)(struct wl_client *client,
						       struct wl_resource *resource,
						       int32_t restore_session_id,
						       const char *restore_window_id_source);
	/**
	 * request a decoration for surface
	 *
	 * Clients are allowed to request a particular decoration for a
	 * zaura_toplevel. The server is not required to honor this
	 * request. See decoration_type for available options. Available
	 * since M105.
	 * @param type the new frame type
	 * @since 35
	 */
	void (*set_decoration)(struct wl_client *client,
			       struct wl_resource *resource,
			       uint32_t type);
	/**
	 * destroy zaura_toplevel
	 *
	 * Destroy this zaura_toplevel object. A client should call
	 * destroy when the role is unmapped from a wl_surface.
	 *
	 * See zaura_shell.release for destructor naming.
	 * @since 38
	 */
	void (*release)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZAURA_TOPLEVEL_CONFIGURE 0
#define ZAURA_TOPLEVEL_ORIGIN_CHANGE 1

/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_CONFIGURE_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_ORIGIN_CHANGE_SINCE_VERSION 29

/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_ORIENTATION_LOCK_SINCE_VERSION 26
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES_SINCE_VERSION 28
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SUPPORTS_SCREEN_COORDINATES_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_WINDOW_BOUNDS_SINCE_VERSION 29
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_RESTORE_INFO_SINCE_VERSION 30
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_SYSTEM_MODAL_SINCE_VERSION 31
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_UNSET_SYSTEM_MODAL_SINCE_VERSION 31
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_RESTORE_INFO_WITH_WINDOW_ID_SOURCE_SINCE_VERSION 32
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_SET_DECORATION_SINCE_VERSION 35
/**
 * @ingroup iface_zaura_toplevel
 */
#define ZAURA_TOPLEVEL_RELEASE_SINCE_VERSION 38

/**
 * @ingroup iface_zaura_toplevel
 * Sends an configure event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_toplevel_send_configure(struct wl_resource *resource_, int32_t x, int32_t y, int32_t width, int32_t height, struct wl_array *states)
{
	wl_resource_post_event(resource_, ZAURA_TOPLEVEL_CONFIGURE, x, y, width, height, states);
}

/**
 * @ingroup iface_zaura_toplevel
 * Sends an origin_change event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zaura_toplevel_send_origin_change(struct wl_resource *resource_, int32_t x, int32_t y)
{
	wl_resource_post_event(resource_, ZAURA_TOPLEVEL_ORIGIN_CHANGE, x, y);
}

#ifndef ZAURA_POPUP_DECORATION_TYPE_ENUM
#define ZAURA_POPUP_DECORATION_TYPE_ENUM
/**
 * @ingroup iface_zaura_popup
 * different decoration types
 *
 * Decoration types are used to modify the surface (e.g. drop shadow).
 */
enum zaura_popup_decoration_type {
	/**
	 * no frame
	 */
	ZAURA_POPUP_DECORATION_TYPE_NONE = 0,
	/**
	 * caption with shadow
	 */
	ZAURA_POPUP_DECORATION_TYPE_NORMAL = 1,
	/**
	 * shadow only
	 */
	ZAURA_POPUP_DECORATION_TYPE_SHADOW = 2,
};
#endif /* ZAURA_POPUP_DECORATION_TYPE_ENUM */

/**
 * @ingroup iface_zaura_popup
 * @struct zaura_popup_interface
 */
struct zaura_popup_interface {
	/**
	 * surface will be submitted in pixel coordinates
	 *
	 * Informs the server that when submitting this surface, this
	 * client will not use wl_surface_set_buffer_scale to report the
	 * scales, nor will it apply scale via vp_viewporter. Instead the
	 * server should apply an appropriate scale transform for the
	 * submitted buffers to be composited correctly.
	 * @since 28
	 */
	void (*surface_submission_in_pixel_coordinates)(struct wl_client *client,
							struct wl_resource *resource);
	/**
	 * request a decoration for surface
	 *
	 * Clients are allowed to request a particular decoration for a
	 * zaura_toplevel. The server is not required to honor this
	 * request. See decoration_type for available options. Available
	 * since M105.
	 * @param type the new frame type
	 * @since 35
	 */
	void (*set_decoration)(struct wl_client *client,
			       struct wl_resource *resource,
			       uint32_t type);
	/**
	 * set popup type to menu
	 *
	 * Set popup type to menu
	 * @since 37
	 */
	void (*set_menu)(struct wl_client *client,
			 struct wl_resource *resource);
	/**
	 * destroy zaura_popup
	 *
	 * This request destroys the zaura_popup. A client should call
	 * destroy when the role is unmapped from a wl_surface.
	 *
	 * See zaura_shell.release for destructor naming.
	 * @since 38
	 */
	void (*release)(struct wl_client *client,
			struct wl_resource *resource);
};


/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_SURFACE_SUBMISSION_IN_PIXEL_COORDINATES_SINCE_VERSION 28
/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_SET_DECORATION_SINCE_VERSION 35
/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_SET_MENU_SINCE_VERSION 37
/**
 * @ingroup iface_zaura_popup
 */
#define ZAURA_POPUP_RELEASE_SINCE_VERSION 38

#ifdef  __cplusplus
}
#endif

#endif
