// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#include "aura-shell-shim.h"

void ZauraShellShim::set_user_data(struct zaura_shell *zaura_shell, void* user_data) {
  zaura_shell_set_user_data(zaura_shell, user_data);
}

void* ZauraShellShim::get_user_data(struct zaura_shell *zaura_shell) {
  return zaura_shell_get_user_data(zaura_shell);
}
int ZauraShellShim::add_listener(struct zaura_shell* zaura_shell, const struct zaura_shell_listener* listener, void* data) {
  return zaura_shell_add_listener(zaura_shell, listener, data);
}

struct zaura_surface* ZauraShellShim::get_aura_surface(
    struct zaura_shell *zaura_shell,
    struct wl_surface* surface) {
  return zaura_shell_get_aura_surface(zaura_shell, surface);
}

struct zaura_output* ZauraShellShim::get_aura_output(
    struct zaura_shell *zaura_shell,
    struct wl_output* output) {
  return zaura_shell_get_aura_output(zaura_shell, output);
}

void ZauraShellShim::surface_submission_in_pixel_coordinates(
    struct zaura_shell *zaura_shell) {
  return zaura_shell_surface_submission_in_pixel_coordinates(zaura_shell);
}

struct zaura_toplevel* ZauraShellShim::get_aura_toplevel_for_xdg_toplevel(
    struct zaura_shell *zaura_shell,
    struct xdg_toplevel* toplevel) {
  return zaura_shell_get_aura_toplevel_for_xdg_toplevel(zaura_shell, toplevel);
}

struct zaura_popup* ZauraShellShim::get_aura_popup_for_xdg_popup(
    struct zaura_shell *zaura_shell,
    struct xdg_popup* popup) {
  return zaura_shell_get_aura_popup_for_xdg_popup(zaura_shell, popup);
}

void ZauraShellShim::release(
    struct zaura_shell *zaura_shell) {
  return zaura_shell_release(zaura_shell);
}

void ZauraShellShim::send_layout_mode(
    struct wl_resource* resource,
    uint32_t layout_mode) {
  zaura_shell_send_layout_mode(resource, layout_mode);
}

void ZauraShellShim::send_bug_fix(
    struct wl_resource* resource,
    uint32_t id) {
  zaura_shell_send_bug_fix(resource, id);
}

void ZauraShellShim::send_desks_changed(
    struct wl_resource* resource,
    struct wl_array* desk_names) {
  zaura_shell_send_desks_changed(resource, desk_names);
}

void ZauraShellShim::send_desk_activation_changed(
    struct wl_resource* resource,
    int32_t active_desk_index) {
  zaura_shell_send_desk_activation_changed(resource, active_desk_index);
}

void ZauraShellShim::send_activated(
    struct wl_resource* resource,
    struct wl_resource * gained_active,
    struct wl_resource * lost_active) {
  zaura_shell_send_activated(resource, gained_active, lost_active);
}
static ZauraShellShim* zaura_shell_singleton = nullptr;

ZauraShellShim* zaura_shell_shim() {
  return zaura_shell_singleton;
}

void set_zaura_shell_shim (ZauraShellShim* shim) {
  zaura_shell_singleton = shim;
}


void ZauraSurfaceShim::set_user_data(struct zaura_surface *zaura_surface, void* user_data) {
  zaura_surface_set_user_data(zaura_surface, user_data);
}

void* ZauraSurfaceShim::get_user_data(struct zaura_surface *zaura_surface) {
  return zaura_surface_get_user_data(zaura_surface);
}
int ZauraSurfaceShim::add_listener(struct zaura_surface* zaura_surface, const struct zaura_surface_listener* listener, void* data) {
  return zaura_surface_add_listener(zaura_surface, listener, data);
}

void ZauraSurfaceShim::set_frame(
    struct zaura_surface *zaura_surface,
    uint32_t type) {
  return zaura_surface_set_frame(zaura_surface, type);
}

void ZauraSurfaceShim::set_parent(
    struct zaura_surface *zaura_surface,
    struct zaura_surface* parent,
    int32_t x,
    int32_t y) {
  return zaura_surface_set_parent(zaura_surface, parent, x, y);
}

void ZauraSurfaceShim::set_frame_colors(
    struct zaura_surface *zaura_surface,
    uint32_t active_color,
    uint32_t inactive_color) {
  return zaura_surface_set_frame_colors(zaura_surface, active_color, inactive_color);
}

void ZauraSurfaceShim::set_startup_id(
    struct zaura_surface *zaura_surface,
    const char * startup_id) {
  return zaura_surface_set_startup_id(zaura_surface, startup_id);
}

void ZauraSurfaceShim::set_application_id(
    struct zaura_surface *zaura_surface,
    const char * application_id) {
  return zaura_surface_set_application_id(zaura_surface, application_id);
}

void ZauraSurfaceShim::set_client_surface_id(
    struct zaura_surface *zaura_surface,
    int32_t client_surface_id) {
  return zaura_surface_set_client_surface_id(zaura_surface, client_surface_id);
}

void ZauraSurfaceShim::set_occlusion_tracking(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_set_occlusion_tracking(zaura_surface);
}

void ZauraSurfaceShim::unset_occlusion_tracking(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_unset_occlusion_tracking(zaura_surface);
}

void ZauraSurfaceShim::activate(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_activate(zaura_surface);
}

void ZauraSurfaceShim::draw_attention(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_draw_attention(zaura_surface);
}

void ZauraSurfaceShim::set_fullscreen_mode(
    struct zaura_surface *zaura_surface,
    uint32_t mode) {
  return zaura_surface_set_fullscreen_mode(zaura_surface, mode);
}

void ZauraSurfaceShim::set_client_surface_str_id(
    struct zaura_surface *zaura_surface,
    const char * client_surface_id) {
  return zaura_surface_set_client_surface_str_id(zaura_surface, client_surface_id);
}

void ZauraSurfaceShim::set_server_start_resize(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_set_server_start_resize(zaura_surface);
}

void ZauraSurfaceShim::intent_to_snap(
    struct zaura_surface *zaura_surface,
    uint32_t direction) {
  return zaura_surface_intent_to_snap(zaura_surface, direction);
}

void ZauraSurfaceShim::set_snap_left(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_set_snap_left(zaura_surface);
}

void ZauraSurfaceShim::set_snap_right(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_set_snap_right(zaura_surface);
}

void ZauraSurfaceShim::unset_snap(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_unset_snap(zaura_surface);
}

void ZauraSurfaceShim::set_window_session_id(
    struct zaura_surface *zaura_surface,
    int32_t id) {
  return zaura_surface_set_window_session_id(zaura_surface, id);
}

void ZauraSurfaceShim::set_can_go_back(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_set_can_go_back(zaura_surface);
}

void ZauraSurfaceShim::unset_can_go_back(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_unset_can_go_back(zaura_surface);
}

void ZauraSurfaceShim::set_pip(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_set_pip(zaura_surface);
}

void ZauraSurfaceShim::unset_pip(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_unset_pip(zaura_surface);
}

void ZauraSurfaceShim::set_aspect_ratio(
    struct zaura_surface *zaura_surface,
    int32_t width,
    int32_t height) {
  return zaura_surface_set_aspect_ratio(zaura_surface, width, height);
}

void ZauraSurfaceShim::move_to_desk(
    struct zaura_surface *zaura_surface,
    int32_t index) {
  return zaura_surface_move_to_desk(zaura_surface, index);
}

void ZauraSurfaceShim::set_initial_workspace(
    struct zaura_surface *zaura_surface,
    const char * initial_workspace) {
  return zaura_surface_set_initial_workspace(zaura_surface, initial_workspace);
}

void ZauraSurfaceShim::set_pin(
    struct zaura_surface *zaura_surface,
    int32_t trusted) {
  return zaura_surface_set_pin(zaura_surface, trusted);
}

void ZauraSurfaceShim::unset_pin(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_unset_pin(zaura_surface);
}

void ZauraSurfaceShim::release(
    struct zaura_surface *zaura_surface) {
  return zaura_surface_release(zaura_surface);
}

void ZauraSurfaceShim::send_occlusion_changed(
    struct wl_resource* resource,
    wl_fixed_t occlusion_fraction,
    uint32_t occlusion_reason) {
  zaura_surface_send_occlusion_changed(resource, occlusion_fraction, occlusion_reason);
}

void ZauraSurfaceShim::send_lock_frame_normal(
    struct wl_resource* resource) {
  zaura_surface_send_lock_frame_normal(resource);
}

void ZauraSurfaceShim::send_unlock_frame_normal(
    struct wl_resource* resource) {
  zaura_surface_send_unlock_frame_normal(resource);
}

void ZauraSurfaceShim::send_occlusion_state_changed(
    struct wl_resource* resource,
    uint32_t mode) {
  zaura_surface_send_occlusion_state_changed(resource, mode);
}

void ZauraSurfaceShim::send_desk_changed(
    struct wl_resource* resource,
    int32_t state) {
  zaura_surface_send_desk_changed(resource, state);
}

void ZauraSurfaceShim::send_start_throttle(
    struct wl_resource* resource) {
  zaura_surface_send_start_throttle(resource);
}

void ZauraSurfaceShim::send_end_throttle(
    struct wl_resource* resource) {
  zaura_surface_send_end_throttle(resource);
}
static ZauraSurfaceShim* zaura_surface_singleton = nullptr;

ZauraSurfaceShim* zaura_surface_shim() {
  return zaura_surface_singleton;
}

void set_zaura_surface_shim (ZauraSurfaceShim* shim) {
  zaura_surface_singleton = shim;
}


void ZauraOutputShim::set_user_data(struct zaura_output *zaura_output, void* user_data) {
  zaura_output_set_user_data(zaura_output, user_data);
}

void* ZauraOutputShim::get_user_data(struct zaura_output *zaura_output) {
  return zaura_output_get_user_data(zaura_output);
}
int ZauraOutputShim::add_listener(struct zaura_output* zaura_output, const struct zaura_output_listener* listener, void* data) {
  return zaura_output_add_listener(zaura_output, listener, data);
}

void ZauraOutputShim::release(
    struct zaura_output *zaura_output) {
  return zaura_output_release(zaura_output);
}

void ZauraOutputShim::send_scale(
    struct wl_resource* resource,
    uint32_t flags,
    uint32_t scale) {
  zaura_output_send_scale(resource, flags, scale);
}

void ZauraOutputShim::send_connection(
    struct wl_resource* resource,
    uint32_t connection) {
  zaura_output_send_connection(resource, connection);
}

void ZauraOutputShim::send_device_scale_factor(
    struct wl_resource* resource,
    uint32_t scale) {
  zaura_output_send_device_scale_factor(resource, scale);
}

void ZauraOutputShim::send_insets(
    struct wl_resource* resource,
    int32_t top,
    int32_t left,
    int32_t bottom,
    int32_t right) {
  zaura_output_send_insets(resource, top, left, bottom, right);
}

void ZauraOutputShim::send_logical_transform(
    struct wl_resource* resource,
    int32_t transform) {
  zaura_output_send_logical_transform(resource, transform);
}
static ZauraOutputShim* zaura_output_singleton = nullptr;

ZauraOutputShim* zaura_output_shim() {
  return zaura_output_singleton;
}

void set_zaura_output_shim (ZauraOutputShim* shim) {
  zaura_output_singleton = shim;
}


void ZauraToplevelShim::set_user_data(struct zaura_toplevel *zaura_toplevel, void* user_data) {
  zaura_toplevel_set_user_data(zaura_toplevel, user_data);
}

void* ZauraToplevelShim::get_user_data(struct zaura_toplevel *zaura_toplevel) {
  return zaura_toplevel_get_user_data(zaura_toplevel);
}
int ZauraToplevelShim::add_listener(struct zaura_toplevel* zaura_toplevel, const struct zaura_toplevel_listener* listener, void* data) {
  return zaura_toplevel_add_listener(zaura_toplevel, listener, data);
}

void ZauraToplevelShim::set_orientation_lock(
    struct zaura_toplevel *zaura_toplevel,
    uint32_t orientation_lock) {
  return zaura_toplevel_set_orientation_lock(zaura_toplevel, orientation_lock);
}

void ZauraToplevelShim::surface_submission_in_pixel_coordinates(
    struct zaura_toplevel *zaura_toplevel) {
  return zaura_toplevel_surface_submission_in_pixel_coordinates(zaura_toplevel);
}

void ZauraToplevelShim::set_supports_screen_coordinates(
    struct zaura_toplevel *zaura_toplevel) {
  return zaura_toplevel_set_supports_screen_coordinates(zaura_toplevel);
}

void ZauraToplevelShim::set_window_bounds(
    struct zaura_toplevel *zaura_toplevel,
    int32_t x,
    int32_t y,
    int32_t width,
    int32_t height,
    struct wl_output* output) {
  return zaura_toplevel_set_window_bounds(zaura_toplevel, x, y, width, height, output);
}

void ZauraToplevelShim::set_restore_info(
    struct zaura_toplevel *zaura_toplevel,
    int32_t restore_session_id,
    int32_t restore_window_id) {
  return zaura_toplevel_set_restore_info(zaura_toplevel, restore_session_id, restore_window_id);
}

void ZauraToplevelShim::set_system_modal(
    struct zaura_toplevel *zaura_toplevel) {
  return zaura_toplevel_set_system_modal(zaura_toplevel);
}

void ZauraToplevelShim::unset_system_modal(
    struct zaura_toplevel *zaura_toplevel) {
  return zaura_toplevel_unset_system_modal(zaura_toplevel);
}

void ZauraToplevelShim::set_restore_info_with_window_id_source(
    struct zaura_toplevel *zaura_toplevel,
    int32_t restore_session_id,
    const char * restore_window_id_source) {
  return zaura_toplevel_set_restore_info_with_window_id_source(zaura_toplevel, restore_session_id, restore_window_id_source);
}

void ZauraToplevelShim::set_decoration(
    struct zaura_toplevel *zaura_toplevel,
    uint32_t type) {
  return zaura_toplevel_set_decoration(zaura_toplevel, type);
}

void ZauraToplevelShim::release(
    struct zaura_toplevel *zaura_toplevel) {
  return zaura_toplevel_release(zaura_toplevel);
}

void ZauraToplevelShim::send_configure(
    struct wl_resource* resource,
    int32_t x,
    int32_t y,
    int32_t width,
    int32_t height,
    struct wl_array* states) {
  zaura_toplevel_send_configure(resource, x, y, width, height, states);
}

void ZauraToplevelShim::send_origin_change(
    struct wl_resource* resource,
    int32_t x,
    int32_t y) {
  zaura_toplevel_send_origin_change(resource, x, y);
}
static ZauraToplevelShim* zaura_toplevel_singleton = nullptr;

ZauraToplevelShim* zaura_toplevel_shim() {
  return zaura_toplevel_singleton;
}

void set_zaura_toplevel_shim (ZauraToplevelShim* shim) {
  zaura_toplevel_singleton = shim;
}


void ZauraPopupShim::set_user_data(struct zaura_popup *zaura_popup, void* user_data) {
  zaura_popup_set_user_data(zaura_popup, user_data);
}

void* ZauraPopupShim::get_user_data(struct zaura_popup *zaura_popup) {
  return zaura_popup_get_user_data(zaura_popup);
}
void ZauraPopupShim::surface_submission_in_pixel_coordinates(
    struct zaura_popup *zaura_popup) {
  return zaura_popup_surface_submission_in_pixel_coordinates(zaura_popup);
}

void ZauraPopupShim::set_decoration(
    struct zaura_popup *zaura_popup,
    uint32_t type) {
  return zaura_popup_set_decoration(zaura_popup, type);
}

void ZauraPopupShim::set_menu(
    struct zaura_popup *zaura_popup) {
  return zaura_popup_set_menu(zaura_popup);
}

void ZauraPopupShim::release(
    struct zaura_popup *zaura_popup) {
  return zaura_popup_release(zaura_popup);
}
static ZauraPopupShim* zaura_popup_singleton = nullptr;

ZauraPopupShim* zaura_popup_shim() {
  return zaura_popup_singleton;
}

void set_zaura_popup_shim (ZauraPopupShim* shim) {
  zaura_popup_singleton = shim;
}
