// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_AURA_SHELL_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_AURA_SHELL_SHIM_H_

#include "aura-shell-client-protocol.h"  // NOLINT(build/include_directory)
#include "aura-shell-server-protocol.h"  // NOLINT(build/include_directory)


class ZauraShellShim {
  public:
    ZauraShellShim() = default;
    ZauraShellShim(ZauraShellShim&&) = delete;
    ZauraShellShim& operator=(ZauraShellShim&&) = delete;
    virtual ~ZauraShellShim() = default;

    virtual void set_user_data(struct zaura_shell* zaura_shell, void* user_data);

    virtual void* get_user_data(struct zaura_shell* zaura_shell);
    virtual int add_listener(struct zaura_shell* zaura_shell, const struct zaura_shell_listener* listener, void* data);
    
    virtual struct zaura_surface* get_aura_surface(
        struct zaura_shell *zaura_shell,
        struct wl_surface* surface);
    
    virtual struct zaura_output* get_aura_output(
        struct zaura_shell *zaura_shell,
        struct wl_output* output);
    
    virtual void surface_submission_in_pixel_coordinates(
        struct zaura_shell *zaura_shell);
    
    virtual struct zaura_toplevel* get_aura_toplevel_for_xdg_toplevel(
        struct zaura_shell *zaura_shell,
        struct xdg_toplevel* toplevel);
    
    virtual struct zaura_popup* get_aura_popup_for_xdg_popup(
        struct zaura_shell *zaura_shell,
        struct xdg_popup* popup);
    
    virtual void release(
        struct zaura_shell *zaura_shell);
    
    virtual void send_layout_mode(
        struct wl_resource* resource,
        uint32_t layout_mode);
    
    virtual void send_bug_fix(
        struct wl_resource* resource,
        uint32_t id);
    
    virtual void send_desks_changed(
        struct wl_resource* resource,
        struct wl_array* desk_names);
    
    virtual void send_desk_activation_changed(
        struct wl_resource* resource,
        int32_t active_desk_index);
    
    virtual void send_activated(
        struct wl_resource* resource,
        struct wl_resource * gained_active,
        struct wl_resource * lost_active);
    };

ZauraShellShim* zaura_shell_shim();
void set_zaura_shell_shim (ZauraShellShim* shim);

class ZauraSurfaceShim {
  public:
    ZauraSurfaceShim() = default;
    ZauraSurfaceShim(ZauraSurfaceShim&&) = delete;
    ZauraSurfaceShim& operator=(ZauraSurfaceShim&&) = delete;
    virtual ~ZauraSurfaceShim() = default;

    virtual void set_user_data(struct zaura_surface* zaura_surface, void* user_data);

    virtual void* get_user_data(struct zaura_surface* zaura_surface);
    virtual int add_listener(struct zaura_surface* zaura_surface, const struct zaura_surface_listener* listener, void* data);
    
    virtual void set_frame(
        struct zaura_surface *zaura_surface,
        uint32_t type);
    
    virtual void set_parent(
        struct zaura_surface *zaura_surface,
        struct zaura_surface* parent,
        int32_t x,
        int32_t y);
    
    virtual void set_frame_colors(
        struct zaura_surface *zaura_surface,
        uint32_t active_color,
        uint32_t inactive_color);
    
    virtual void set_startup_id(
        struct zaura_surface *zaura_surface,
        const char * startup_id);
    
    virtual void set_application_id(
        struct zaura_surface *zaura_surface,
        const char * application_id);
    
    virtual void set_client_surface_id(
        struct zaura_surface *zaura_surface,
        int32_t client_surface_id);
    
    virtual void set_occlusion_tracking(
        struct zaura_surface *zaura_surface);
    
    virtual void unset_occlusion_tracking(
        struct zaura_surface *zaura_surface);
    
    virtual void activate(
        struct zaura_surface *zaura_surface);
    
    virtual void draw_attention(
        struct zaura_surface *zaura_surface);
    
    virtual void set_fullscreen_mode(
        struct zaura_surface *zaura_surface,
        uint32_t mode);
    
    virtual void set_client_surface_str_id(
        struct zaura_surface *zaura_surface,
        const char * client_surface_id);
    
    virtual void set_server_start_resize(
        struct zaura_surface *zaura_surface);
    
    virtual void intent_to_snap(
        struct zaura_surface *zaura_surface,
        uint32_t direction);
    
    virtual void set_snap_left(
        struct zaura_surface *zaura_surface);
    
    virtual void set_snap_right(
        struct zaura_surface *zaura_surface);
    
    virtual void unset_snap(
        struct zaura_surface *zaura_surface);
    
    virtual void set_window_session_id(
        struct zaura_surface *zaura_surface,
        int32_t id);
    
    virtual void set_can_go_back(
        struct zaura_surface *zaura_surface);
    
    virtual void unset_can_go_back(
        struct zaura_surface *zaura_surface);
    
    virtual void set_pip(
        struct zaura_surface *zaura_surface);
    
    virtual void unset_pip(
        struct zaura_surface *zaura_surface);
    
    virtual void set_aspect_ratio(
        struct zaura_surface *zaura_surface,
        int32_t width,
        int32_t height);
    
    virtual void move_to_desk(
        struct zaura_surface *zaura_surface,
        int32_t index);
    
    virtual void set_initial_workspace(
        struct zaura_surface *zaura_surface,
        const char * initial_workspace);
    
    virtual void set_pin(
        struct zaura_surface *zaura_surface,
        int32_t trusted);
    
    virtual void unset_pin(
        struct zaura_surface *zaura_surface);
    
    virtual void release(
        struct zaura_surface *zaura_surface);
    
    virtual void send_occlusion_changed(
        struct wl_resource* resource,
        wl_fixed_t occlusion_fraction,
        uint32_t occlusion_reason);
    
    virtual void send_lock_frame_normal(
        struct wl_resource* resource);
    
    virtual void send_unlock_frame_normal(
        struct wl_resource* resource);
    
    virtual void send_occlusion_state_changed(
        struct wl_resource* resource,
        uint32_t mode);
    
    virtual void send_desk_changed(
        struct wl_resource* resource,
        int32_t state);
    
    virtual void send_start_throttle(
        struct wl_resource* resource);
    
    virtual void send_end_throttle(
        struct wl_resource* resource);
    };

ZauraSurfaceShim* zaura_surface_shim();
void set_zaura_surface_shim (ZauraSurfaceShim* shim);

class ZauraOutputShim {
  public:
    ZauraOutputShim() = default;
    ZauraOutputShim(ZauraOutputShim&&) = delete;
    ZauraOutputShim& operator=(ZauraOutputShim&&) = delete;
    virtual ~ZauraOutputShim() = default;

    virtual void set_user_data(struct zaura_output* zaura_output, void* user_data);

    virtual void* get_user_data(struct zaura_output* zaura_output);
    virtual int add_listener(struct zaura_output* zaura_output, const struct zaura_output_listener* listener, void* data);
    
    virtual void release(
        struct zaura_output *zaura_output);
    
    virtual void send_scale(
        struct wl_resource* resource,
        uint32_t flags,
        uint32_t scale);
    
    virtual void send_connection(
        struct wl_resource* resource,
        uint32_t connection);
    
    virtual void send_device_scale_factor(
        struct wl_resource* resource,
        uint32_t scale);
    
    virtual void send_insets(
        struct wl_resource* resource,
        int32_t top,
        int32_t left,
        int32_t bottom,
        int32_t right);
    
    virtual void send_logical_transform(
        struct wl_resource* resource,
        int32_t transform);
    };

ZauraOutputShim* zaura_output_shim();
void set_zaura_output_shim (ZauraOutputShim* shim);

class ZauraToplevelShim {
  public:
    ZauraToplevelShim() = default;
    ZauraToplevelShim(ZauraToplevelShim&&) = delete;
    ZauraToplevelShim& operator=(ZauraToplevelShim&&) = delete;
    virtual ~ZauraToplevelShim() = default;

    virtual void set_user_data(struct zaura_toplevel* zaura_toplevel, void* user_data);

    virtual void* get_user_data(struct zaura_toplevel* zaura_toplevel);
    virtual int add_listener(struct zaura_toplevel* zaura_toplevel, const struct zaura_toplevel_listener* listener, void* data);
    
    virtual void set_orientation_lock(
        struct zaura_toplevel *zaura_toplevel,
        uint32_t orientation_lock);
    
    virtual void surface_submission_in_pixel_coordinates(
        struct zaura_toplevel *zaura_toplevel);
    
    virtual void set_supports_screen_coordinates(
        struct zaura_toplevel *zaura_toplevel);
    
    virtual void set_window_bounds(
        struct zaura_toplevel *zaura_toplevel,
        int32_t x,
        int32_t y,
        int32_t width,
        int32_t height,
        struct wl_output* output);
    
    virtual void set_restore_info(
        struct zaura_toplevel *zaura_toplevel,
        int32_t restore_session_id,
        int32_t restore_window_id);
    
    virtual void set_system_modal(
        struct zaura_toplevel *zaura_toplevel);
    
    virtual void unset_system_modal(
        struct zaura_toplevel *zaura_toplevel);
    
    virtual void set_restore_info_with_window_id_source(
        struct zaura_toplevel *zaura_toplevel,
        int32_t restore_session_id,
        const char * restore_window_id_source);
    
    virtual void set_decoration(
        struct zaura_toplevel *zaura_toplevel,
        uint32_t type);
    
    virtual void release(
        struct zaura_toplevel *zaura_toplevel);
    
    virtual void send_configure(
        struct wl_resource* resource,
        int32_t x,
        int32_t y,
        int32_t width,
        int32_t height,
        struct wl_array* states);
    
    virtual void send_origin_change(
        struct wl_resource* resource,
        int32_t x,
        int32_t y);
    };

ZauraToplevelShim* zaura_toplevel_shim();
void set_zaura_toplevel_shim (ZauraToplevelShim* shim);

class ZauraPopupShim {
  public:
    ZauraPopupShim() = default;
    ZauraPopupShim(ZauraPopupShim&&) = delete;
    ZauraPopupShim& operator=(ZauraPopupShim&&) = delete;
    virtual ~ZauraPopupShim() = default;

    virtual void set_user_data(struct zaura_popup* zaura_popup, void* user_data);

    virtual void* get_user_data(struct zaura_popup* zaura_popup);
    virtual void surface_submission_in_pixel_coordinates(
        struct zaura_popup *zaura_popup);
    
    virtual void set_decoration(
        struct zaura_popup *zaura_popup,
        uint32_t type);
    
    virtual void set_menu(
        struct zaura_popup *zaura_popup);
    
    virtual void release(
        struct zaura_popup *zaura_popup);
    };

ZauraPopupShim* zaura_popup_shim();
void set_zaura_popup_shim (ZauraPopupShim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_AURA_SHELL_SHIM_H_