// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_DRM_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_DRM_SHIM_H_

#include "drm-client-protocol.h"  // NOLINT(build/include_directory)
#include "drm-server-protocol.h"  // NOLINT(build/include_directory)


class WlDrmShim {
  public:
    WlDrmShim() = default;
    WlDrmShim(WlDrmShim&&) = delete;
    WlDrmShim& operator=(WlDrmShim&&) = delete;
    virtual ~WlDrmShim() = default;

    virtual void set_user_data(struct wl_drm* wl_drm, void* user_data);

    virtual void* get_user_data(struct wl_drm* wl_drm);
    virtual int add_listener(struct wl_drm* wl_drm, const struct wl_drm_listener* listener, void* data);
    
    virtual void authenticate(
        struct wl_drm *wl_drm,
        uint32_t id);
    
    virtual struct wl_buffer* create_buffer(
        struct wl_drm *wl_drm,
        uint32_t name,
        int32_t width,
        int32_t height,
        uint32_t stride,
        uint32_t format);
    
    virtual struct wl_buffer* create_planar_buffer(
        struct wl_drm *wl_drm,
        uint32_t name,
        int32_t width,
        int32_t height,
        uint32_t format,
        int32_t offset0,
        int32_t stride0,
        int32_t offset1,
        int32_t stride1,
        int32_t offset2,
        int32_t stride2);
    
    virtual struct wl_buffer* create_prime_buffer(
        struct wl_drm *wl_drm,
        int32_t name,
        int32_t width,
        int32_t height,
        uint32_t format,
        int32_t offset0,
        int32_t stride0,
        int32_t offset1,
        int32_t stride1,
        int32_t offset2,
        int32_t stride2);
    
    virtual void send_device(
        struct wl_resource* resource,
        const char * name);
    
    virtual void send_format(
        struct wl_resource* resource,
        uint32_t format);
    
    virtual void send_authenticated(
        struct wl_resource* resource);
    
    virtual void send_capabilities(
        struct wl_resource* resource,
        uint32_t value);
    };

WlDrmShim* wl_drm_shim();
void set_wl_drm_shim (WlDrmShim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_DRM_SHIM_H_