/* Generated by wayland-scanner 1.22.0 */

#ifndef GAMING_INPUT_UNSTABLE_V2_SERVER_PROTOCOL_H
#define GAMING_INPUT_UNSTABLE_V2_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_gaming_input_unstable_v2 The gaming_input_unstable_v2 protocol
 * @section page_ifaces_gaming_input_unstable_v2 Interfaces
 * - @subpage page_iface_zcr_gaming_input_v2 - extends wl_seat with gaming input devices
 * - @subpage page_iface_zcr_gaming_seat_v2 - controller object for all gaming devices of a seat
 * - @subpage page_iface_zcr_gamepad_v2 - gamepad input device
 * - @subpage page_iface_zcr_gamepad_vibrator_v2 - vibrator interface for a gamepad
 * @section page_copyright_gaming_input_unstable_v2 Copyright
 * <pre>
 *
 * Copyright 2016 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct wl_seat;
struct zcr_gamepad_v2;
struct zcr_gamepad_vibrator_v2;
struct zcr_gaming_input_v2;
struct zcr_gaming_seat_v2;

#ifndef ZCR_GAMING_INPUT_V2_INTERFACE
#define ZCR_GAMING_INPUT_V2_INTERFACE
/**
 * @page page_iface_zcr_gaming_input_v2 zcr_gaming_input_v2
 * @section page_iface_zcr_gaming_input_v2_desc Description
 *
 * A global interface to provide gaming input devices for a given seat.
 *
 * Currently only gamepad devices are supported.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding uinterface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and uinterface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 * @section page_iface_zcr_gaming_input_v2_api API
 * See @ref iface_zcr_gaming_input_v2.
 */
/**
 * @defgroup iface_zcr_gaming_input_v2 The zcr_gaming_input_v2 interface
 *
 * A global interface to provide gaming input devices for a given seat.
 *
 * Currently only gamepad devices are supported.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding uinterface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and uinterface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 */
extern const struct wl_interface zcr_gaming_input_v2_interface;
#endif
#ifndef ZCR_GAMING_SEAT_V2_INTERFACE
#define ZCR_GAMING_SEAT_V2_INTERFACE
/**
 * @page page_iface_zcr_gaming_seat_v2 zcr_gaming_seat_v2
 * @section page_iface_zcr_gaming_seat_v2_desc Description
 *
 * An object that provides access to all the gaming devices of a seat.
 * When a gamepad is connected, the compositor will send gamepad_added event.
 * @section page_iface_zcr_gaming_seat_v2_api API
 * See @ref iface_zcr_gaming_seat_v2.
 */
/**
 * @defgroup iface_zcr_gaming_seat_v2 The zcr_gaming_seat_v2 interface
 *
 * An object that provides access to all the gaming devices of a seat.
 * When a gamepad is connected, the compositor will send gamepad_added event.
 */
extern const struct wl_interface zcr_gaming_seat_v2_interface;
#endif
#ifndef ZCR_GAMEPAD_V2_INTERFACE
#define ZCR_GAMEPAD_V2_INTERFACE
/**
 * @page page_iface_zcr_gamepad_v2 zcr_gamepad_v2
 * @section page_iface_zcr_gamepad_v2_desc Description
 *
 * The zcr_gamepad_v2 interface represents one or more gamepad input devices,
 * which are reported as a normalized 'Standard Gamepad' as it is specified
 * by the W3C Gamepad API at: https://w3c.github.io/gamepad/#remapping
 * @section page_iface_zcr_gamepad_v2_api API
 * See @ref iface_zcr_gamepad_v2.
 */
/**
 * @defgroup iface_zcr_gamepad_v2 The zcr_gamepad_v2 interface
 *
 * The zcr_gamepad_v2 interface represents one or more gamepad input devices,
 * which are reported as a normalized 'Standard Gamepad' as it is specified
 * by the W3C Gamepad API at: https://w3c.github.io/gamepad/#remapping
 */
extern const struct wl_interface zcr_gamepad_v2_interface;
#endif
#ifndef ZCR_GAMEPAD_VIBRATOR_V2_INTERFACE
#define ZCR_GAMEPAD_VIBRATOR_V2_INTERFACE
/**
 * @page page_iface_zcr_gamepad_vibrator_v2 zcr_gamepad_vibrator_v2
 * @section page_iface_zcr_gamepad_vibrator_v2_desc Description
 *
 * An interface that provides access to the vibrator of a gamepad. Requests can be
 * sent to make the gamepad vibrate and to stop an ongoing vibration.
 * @section page_iface_zcr_gamepad_vibrator_v2_api API
 * See @ref iface_zcr_gamepad_vibrator_v2.
 */
/**
 * @defgroup iface_zcr_gamepad_vibrator_v2 The zcr_gamepad_vibrator_v2 interface
 *
 * An interface that provides access to the vibrator of a gamepad. Requests can be
 * sent to make the gamepad vibrate and to stop an ongoing vibration.
 */
extern const struct wl_interface zcr_gamepad_vibrator_v2_interface;
#endif

/**
 * @ingroup iface_zcr_gaming_input_v2
 * @struct zcr_gaming_input_v2_interface
 */
struct zcr_gaming_input_v2_interface {
	/**
	 * get a gaming seat
	 *
	 * Get a gaming seat object for a given seat. Gaming seat
	 * provides access to gaming devices
	 */
	void (*get_gaming_seat)(struct wl_client *client,
				struct wl_resource *resource,
				uint32_t gaming_seat,
				struct wl_resource *seat);
	/**
	 * release the memory for the gaming input object
	 *
	 * Destroy gaming_input object. Objects created from this object
	 * are unaffected and should be destroyed separately.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};


/**
 * @ingroup iface_zcr_gaming_input_v2
 */
#define ZCR_GAMING_INPUT_V2_GET_GAMING_SEAT_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gaming_input_v2
 */
#define ZCR_GAMING_INPUT_V2_DESTROY_SINCE_VERSION 1

#ifndef ZCR_GAMING_SEAT_V2_BUS_TYPE_ENUM
#define ZCR_GAMING_SEAT_V2_BUS_TYPE_ENUM
/**
 * @ingroup iface_zcr_gaming_seat_v2
 * gamepad device bus type
 *
 * Device connection type e.g. Bluetooth
 */
enum zcr_gaming_seat_v2_bus_type {
	/**
	 * Universal Serial Bus
	 */
	ZCR_GAMING_SEAT_V2_BUS_TYPE_USB = 0,
	/**
	 * Bluetooth
	 */
	ZCR_GAMING_SEAT_V2_BUS_TYPE_BLUETOOTH = 1,
};
#endif /* ZCR_GAMING_SEAT_V2_BUS_TYPE_ENUM */

/**
 * @ingroup iface_zcr_gaming_seat_v2
 * @struct zcr_gaming_seat_v2_interface
 */
struct zcr_gaming_seat_v2_interface {
	/**
	 * release the memory for the gaming seat object
	 *
	 * Destroy gaming_seat object. Objects created from this object
	 * are unaffected and should be destroyed separately.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZCR_GAMING_SEAT_V2_GAMEPAD_ADDED 0
#define ZCR_GAMING_SEAT_V2_GAMEPAD_ADDED_WITH_DEVICE_INFO 1

/**
 * @ingroup iface_zcr_gaming_seat_v2
 */
#define ZCR_GAMING_SEAT_V2_GAMEPAD_ADDED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gaming_seat_v2
 */
#define ZCR_GAMING_SEAT_V2_GAMEPAD_ADDED_WITH_DEVICE_INFO_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_gaming_seat_v2
 */
#define ZCR_GAMING_SEAT_V2_DESTROY_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_gaming_seat_v2
 * Sends an gamepad_added event to the client owning the resource.
 * @param resource_ The client's resource
 * @param gamepad new connected gamepad
 */
static inline void
zcr_gaming_seat_v2_send_gamepad_added(struct wl_resource *resource_, struct wl_resource *gamepad)
{
	wl_resource_post_event(resource_, ZCR_GAMING_SEAT_V2_GAMEPAD_ADDED, gamepad);
}

/**
 * @ingroup iface_zcr_gaming_seat_v2
 * Sends an gamepad_added_with_device_info event to the client owning the resource.
 * @param resource_ The client's resource
 * @param gamepad new connected gamepad
 * @param name name of the gamepad device
 * @param bus type of the device connection e.g. Bluetooth
 * @param vendor_id vendor ID of the gamepad device
 * @param product_id product ID of the gamepad device
 * @param version product version of the gamepad device
 */
static inline void
zcr_gaming_seat_v2_send_gamepad_added_with_device_info(struct wl_resource *resource_, struct wl_resource *gamepad, const char *name, uint32_t bus, uint32_t vendor_id, uint32_t product_id, uint32_t version)
{
	wl_resource_post_event(resource_, ZCR_GAMING_SEAT_V2_GAMEPAD_ADDED_WITH_DEVICE_INFO, gamepad, name, bus, vendor_id, product_id, version);
}

#ifndef ZCR_GAMEPAD_V2_BUTTON_STATE_ENUM
#define ZCR_GAMEPAD_V2_BUTTON_STATE_ENUM
/**
 * @ingroup iface_zcr_gamepad_v2
 * physical button state
 *
 * Describes the physical state of a button that produced the button
 * event.
 */
enum zcr_gamepad_v2_button_state {
	/**
	 * the button is not pressed
	 */
	ZCR_GAMEPAD_V2_BUTTON_STATE_RELEASED = 0,
	/**
	 * the button is pressed
	 */
	ZCR_GAMEPAD_V2_BUTTON_STATE_PRESSED = 1,
};
#endif /* ZCR_GAMEPAD_V2_BUTTON_STATE_ENUM */

/**
 * @ingroup iface_zcr_gamepad_v2
 * @struct zcr_gamepad_v2_interface
 */
struct zcr_gamepad_v2_interface {
	/**
	 * destroy gamepad
	 *
	 * Destroy gamepad. Instances created from this gamepad are
	 * unaffected and should be destroyed separately.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};

#define ZCR_GAMEPAD_V2_REMOVED 0
#define ZCR_GAMEPAD_V2_AXIS 1
#define ZCR_GAMEPAD_V2_BUTTON 2
#define ZCR_GAMEPAD_V2_FRAME 3
#define ZCR_GAMEPAD_V2_AXIS_ADDED 4
#define ZCR_GAMEPAD_V2_ACTIVATED 5
#define ZCR_GAMEPAD_V2_VIBRATOR_ADDED 6

/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_REMOVED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_AXIS_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_BUTTON_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_FRAME_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_AXIS_ADDED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_ACTIVATED_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_VIBRATOR_ADDED_SINCE_VERSION 2

/**
 * @ingroup iface_zcr_gamepad_v2
 */
#define ZCR_GAMEPAD_V2_DESTROY_SINCE_VERSION 1

/**
 * @ingroup iface_zcr_gamepad_v2
 * Sends an removed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zcr_gamepad_v2_send_removed(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZCR_GAMEPAD_V2_REMOVED);
}

/**
 * @ingroup iface_zcr_gamepad_v2
 * Sends an axis event to the client owning the resource.
 * @param resource_ The client's resource
 * @param time timestamp with millisecond granularity
 * @param axis axis that produced this event
 * @param value new value of axis
 */
static inline void
zcr_gamepad_v2_send_axis(struct wl_resource *resource_, uint32_t time, uint32_t axis, wl_fixed_t value)
{
	wl_resource_post_event(resource_, ZCR_GAMEPAD_V2_AXIS, time, axis, value);
}

/**
 * @ingroup iface_zcr_gamepad_v2
 * Sends an button event to the client owning the resource.
 * @param resource_ The client's resource
 * @param time timestamp with millisecond granularity
 * @param button id of button
 * @param state digital state of the button
 * @param analog analog value of the button
 */
static inline void
zcr_gamepad_v2_send_button(struct wl_resource *resource_, uint32_t time, uint32_t button, uint32_t state, wl_fixed_t analog)
{
	wl_resource_post_event(resource_, ZCR_GAMEPAD_V2_BUTTON, time, button, state, analog);
}

/**
 * @ingroup iface_zcr_gamepad_v2
 * Sends an frame event to the client owning the resource.
 * @param resource_ The client's resource
 * @param time timestamp with millisecond granularity
 */
static inline void
zcr_gamepad_v2_send_frame(struct wl_resource *resource_, uint32_t time)
{
	wl_resource_post_event(resource_, ZCR_GAMEPAD_V2_FRAME, time);
}

/**
 * @ingroup iface_zcr_gamepad_v2
 * Sends an axis_added event to the client owning the resource.
 * @param resource_ The client's resource
 * @param index An index of the axis
 * @param min_value minimum value of the axis
 * @param max_value maximum value of the axis
 * @param flat input within this value are ignored
 * @param fuzz used to filter noise
 * @param resolution resolution of input in units per millimeter, or units per radian for rotational axes.
 */
static inline void
zcr_gamepad_v2_send_axis_added(struct wl_resource *resource_, uint32_t index, int32_t min_value, int32_t max_value, int32_t flat, int32_t fuzz, int32_t resolution)
{
	wl_resource_post_event(resource_, ZCR_GAMEPAD_V2_AXIS_ADDED, index, min_value, max_value, flat, fuzz, resolution);
}

/**
 * @ingroup iface_zcr_gamepad_v2
 * Sends an activated event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
zcr_gamepad_v2_send_activated(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ZCR_GAMEPAD_V2_ACTIVATED);
}

/**
 * @ingroup iface_zcr_gamepad_v2
 * Sends an vibrator_added event to the client owning the resource.
 * @param resource_ The client's resource
 * @param vibrator the gamepad vibrator
 */
static inline void
zcr_gamepad_v2_send_vibrator_added(struct wl_resource *resource_, struct wl_resource *vibrator)
{
	wl_resource_post_event(resource_, ZCR_GAMEPAD_V2_VIBRATOR_ADDED, vibrator);
}

/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 * @struct zcr_gamepad_vibrator_v2_interface
 */
struct zcr_gamepad_vibrator_v2_interface {
	/**
	 * triggers the vibration event
	 *
	 * Triggers the vibration event on the gamepad vibrator. The
	 * gamepad is only allowed to vibrate while the window is in focus.
	 * The values in the timings array are 64-bit integers and the
	 * values in the amplitudes array are unsigned 8-bit integers. The
	 * timings array and the amplitudes array are of the same length.
	 * For each timing/amplitude pair, the amplitude determines the
	 * strength of the vibration and the timing determines the length
	 * of the vibration in milliseconds. Amplitude values must be
	 * between 0 and 255. An amplitude of 0 implies no vibration and
	 * any timing/amplitude pair with a timing value of 0 is ignored.
	 * The repeat argument determines the index at which the vibration
	 * pattern to repeat begins. A repeat value of -1 disables
	 * repetition. If repetition is enabled, the vibration pattern will
	 * repeat indefinitely until stopped, or when focus is lost.
	 * @param timings array of timing values
	 * @param amplitudes array of amplitude values
	 * @param repeat index into the timings array at which to repeat
	 * @since 2
	 */
	void (*vibrate)(struct wl_client *client,
			struct wl_resource *resource,
			struct wl_array *timings,
			struct wl_array *amplitudes,
			int32_t repeat);
	/**
	 * cancels the existing vibration event
	 *
	 * Cancels the currently ongoing vibration event on the gamepad
	 * vibrator.
	 * @since 2
	 */
	void (*cancel_vibration)(struct wl_client *client,
				 struct wl_resource *resource);
	/**
	 * destroy gamepad vibrator
	 *
	 * 
	 * @since 2
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};


/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 */
#define ZCR_GAMEPAD_VIBRATOR_V2_VIBRATE_SINCE_VERSION 2
/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 */
#define ZCR_GAMEPAD_VIBRATOR_V2_CANCEL_VIBRATION_SINCE_VERSION 2
/**
 * @ingroup iface_zcr_gamepad_vibrator_v2
 */
#define ZCR_GAMEPAD_VIBRATOR_V2_DESTROY_SINCE_VERSION 2

#ifdef  __cplusplus
}
#endif

#endif
