// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_GAMING_INPUT_UNSTABLE_V2_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_GAMING_INPUT_UNSTABLE_V2_SHIM_H_

#include "gaming-input-unstable-v2-client-protocol.h"  // NOLINT(build/include_directory)
#include "gaming-input-unstable-v2-server-protocol.h"  // NOLINT(build/include_directory)


class ZcrGamingInputV2Shim {
  public:
    ZcrGamingInputV2Shim() = default;
    ZcrGamingInputV2Shim(ZcrGamingInputV2Shim&&) = delete;
    ZcrGamingInputV2Shim& operator=(ZcrGamingInputV2Shim&&) = delete;
    virtual ~ZcrGamingInputV2Shim() = default;

    virtual void set_user_data(struct zcr_gaming_input_v2* zcr_gaming_input_v2, void* user_data);

    virtual void* get_user_data(struct zcr_gaming_input_v2* zcr_gaming_input_v2);
    virtual struct zcr_gaming_seat_v2* get_gaming_seat(
        struct zcr_gaming_input_v2 *zcr_gaming_input_v2,
        struct wl_seat* seat);
    
    virtual void destroy(
        struct zcr_gaming_input_v2 *zcr_gaming_input_v2);
    };

ZcrGamingInputV2Shim* zcr_gaming_input_v2_shim();
void set_zcr_gaming_input_v2_shim (ZcrGamingInputV2Shim* shim);

class ZcrGamingSeatV2Shim {
  public:
    ZcrGamingSeatV2Shim() = default;
    ZcrGamingSeatV2Shim(ZcrGamingSeatV2Shim&&) = delete;
    ZcrGamingSeatV2Shim& operator=(ZcrGamingSeatV2Shim&&) = delete;
    virtual ~ZcrGamingSeatV2Shim() = default;

    virtual void set_user_data(struct zcr_gaming_seat_v2* zcr_gaming_seat_v2, void* user_data);

    virtual void* get_user_data(struct zcr_gaming_seat_v2* zcr_gaming_seat_v2);
    virtual int add_listener(struct zcr_gaming_seat_v2* zcr_gaming_seat_v2, const struct zcr_gaming_seat_v2_listener* listener, void* data);
    
    virtual void destroy(
        struct zcr_gaming_seat_v2 *zcr_gaming_seat_v2);
    
    virtual void send_gamepad_added(
        struct wl_resource* resource,
        struct wl_resource * gamepad);
    
    virtual void send_gamepad_added_with_device_info(
        struct wl_resource* resource,
        struct wl_resource * gamepad,
        const char * name,
        uint32_t bus,
        uint32_t vendor_id,
        uint32_t product_id,
        uint32_t version);
    };

ZcrGamingSeatV2Shim* zcr_gaming_seat_v2_shim();
void set_zcr_gaming_seat_v2_shim (ZcrGamingSeatV2Shim* shim);

class ZcrGamepadV2Shim {
  public:
    ZcrGamepadV2Shim() = default;
    ZcrGamepadV2Shim(ZcrGamepadV2Shim&&) = delete;
    ZcrGamepadV2Shim& operator=(ZcrGamepadV2Shim&&) = delete;
    virtual ~ZcrGamepadV2Shim() = default;

    virtual void set_user_data(struct zcr_gamepad_v2* zcr_gamepad_v2, void* user_data);

    virtual void* get_user_data(struct zcr_gamepad_v2* zcr_gamepad_v2);
    virtual int add_listener(struct zcr_gamepad_v2* zcr_gamepad_v2, const struct zcr_gamepad_v2_listener* listener, void* data);
    
    virtual void destroy(
        struct zcr_gamepad_v2 *zcr_gamepad_v2);
    
    virtual void send_removed(
        struct wl_resource* resource);
    
    virtual void send_axis(
        struct wl_resource* resource,
        uint32_t time,
        uint32_t axis,
        wl_fixed_t value);
    
    virtual void send_button(
        struct wl_resource* resource,
        uint32_t time,
        uint32_t button,
        uint32_t state,
        wl_fixed_t analog);
    
    virtual void send_frame(
        struct wl_resource* resource,
        uint32_t time);
    
    virtual void send_axis_added(
        struct wl_resource* resource,
        uint32_t index,
        int32_t min_value,
        int32_t max_value,
        int32_t flat,
        int32_t fuzz,
        int32_t resolution);
    
    virtual void send_activated(
        struct wl_resource* resource);
    
    virtual void send_vibrator_added(
        struct wl_resource* resource,
        struct wl_resource * vibrator);
    };

ZcrGamepadV2Shim* zcr_gamepad_v2_shim();
void set_zcr_gamepad_v2_shim (ZcrGamepadV2Shim* shim);

class ZcrGamepadVibratorV2Shim {
  public:
    ZcrGamepadVibratorV2Shim() = default;
    ZcrGamepadVibratorV2Shim(ZcrGamepadVibratorV2Shim&&) = delete;
    ZcrGamepadVibratorV2Shim& operator=(ZcrGamepadVibratorV2Shim&&) = delete;
    virtual ~ZcrGamepadVibratorV2Shim() = default;

    virtual void set_user_data(struct zcr_gamepad_vibrator_v2* zcr_gamepad_vibrator_v2, void* user_data);

    virtual void* get_user_data(struct zcr_gamepad_vibrator_v2* zcr_gamepad_vibrator_v2);
    virtual void vibrate(
        struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2,
        struct wl_array* timings,
        struct wl_array* amplitudes,
        int32_t repeat);
    
    virtual void cancel_vibration(
        struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2);
    
    virtual void destroy(
        struct zcr_gamepad_vibrator_v2 *zcr_gamepad_vibrator_v2);
    };

ZcrGamepadVibratorV2Shim* zcr_gamepad_vibrator_v2_shim();
void set_zcr_gamepad_vibrator_v2_shim (ZcrGamepadVibratorV2Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_GAMING_INPUT_UNSTABLE_V2_SHIM_H_