// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_GTK_SHELL_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_GTK_SHELL_SHIM_H_

#include "gtk-shell-client-protocol.h"  // NOLINT(build/include_directory)
#include "gtk-shell-server-protocol.h"  // NOLINT(build/include_directory)


class GtkShell1Shim {
  public:
    GtkShell1Shim() = default;
    GtkShell1Shim(GtkShell1Shim&&) = delete;
    GtkShell1Shim& operator=(GtkShell1Shim&&) = delete;
    virtual ~GtkShell1Shim() = default;

    virtual void set_user_data(struct gtk_shell1* gtk_shell1, void* user_data);

    virtual void* get_user_data(struct gtk_shell1* gtk_shell1);
    virtual int add_listener(struct gtk_shell1* gtk_shell1, const struct gtk_shell1_listener* listener, void* data);
    
    virtual struct gtk_surface1* get_gtk_surface(
        struct gtk_shell1 *gtk_shell1,
        struct wl_surface* surface);
    
    virtual void set_startup_id(
        struct gtk_shell1 *gtk_shell1,
        const char * startup_id);
    
    virtual void system_bell(
        struct gtk_shell1 *gtk_shell1,
        struct gtk_surface1* surface);
    
    virtual void send_capabilities(
        struct wl_resource* resource,
        uint32_t capabilities);
    };

GtkShell1Shim* gtk_shell1_shim();
void set_gtk_shell1_shim (GtkShell1Shim* shim);

class GtkSurface1Shim {
  public:
    GtkSurface1Shim() = default;
    GtkSurface1Shim(GtkSurface1Shim&&) = delete;
    GtkSurface1Shim& operator=(GtkSurface1Shim&&) = delete;
    virtual ~GtkSurface1Shim() = default;

    virtual void set_user_data(struct gtk_surface1* gtk_surface1, void* user_data);

    virtual void* get_user_data(struct gtk_surface1* gtk_surface1);
    virtual int add_listener(struct gtk_surface1* gtk_surface1, const struct gtk_surface1_listener* listener, void* data);
    
    virtual void set_dbus_properties(
        struct gtk_surface1 *gtk_surface1,
        const char * application_id,
        const char * app_menu_path,
        const char * menubar_path,
        const char * window_object_path,
        const char * application_object_path,
        const char * unique_bus_name);
    
    virtual void set_modal(
        struct gtk_surface1 *gtk_surface1);
    
    virtual void unset_modal(
        struct gtk_surface1 *gtk_surface1);
    
    virtual void present(
        struct gtk_surface1 *gtk_surface1,
        uint32_t time);
    
    virtual void send_configure(
        struct wl_resource* resource,
        struct wl_array* states);
    };

GtkSurface1Shim* gtk_surface1_shim();
void set_gtk_surface1_shim (GtkSurface1Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_GTK_SHELL_SHIM_H_