// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_LINUX_DMABUF_UNSTABLE_V1_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_LINUX_DMABUF_UNSTABLE_V1_SHIM_H_

#include "linux-dmabuf-unstable-v1-client-protocol.h"  // NOLINT(build/include_directory)
#include "linux-dmabuf-unstable-v1-server-protocol.h"  // NOLINT(build/include_directory)


class ZwpLinuxDmabufV1Shim {
  public:
    ZwpLinuxDmabufV1Shim() = default;
    ZwpLinuxDmabufV1Shim(ZwpLinuxDmabufV1Shim&&) = delete;
    ZwpLinuxDmabufV1Shim& operator=(ZwpLinuxDmabufV1Shim&&) = delete;
    virtual ~ZwpLinuxDmabufV1Shim() = default;

    virtual void set_user_data(struct zwp_linux_dmabuf_v1* zwp_linux_dmabuf_v1, void* user_data);

    virtual void* get_user_data(struct zwp_linux_dmabuf_v1* zwp_linux_dmabuf_v1);
    virtual int add_listener(struct zwp_linux_dmabuf_v1* zwp_linux_dmabuf_v1, const struct zwp_linux_dmabuf_v1_listener* listener, void* data);
    
    virtual void destroy(
        struct zwp_linux_dmabuf_v1 *zwp_linux_dmabuf_v1);
    
    virtual struct zwp_linux_buffer_params_v1* create_params(
        struct zwp_linux_dmabuf_v1 *zwp_linux_dmabuf_v1);
    
    virtual void send_format(
        struct wl_resource* resource,
        uint32_t format);
    
    virtual void send_modifier(
        struct wl_resource* resource,
        uint32_t format,
        uint32_t modifier_hi,
        uint32_t modifier_lo);
    };

ZwpLinuxDmabufV1Shim* zwp_linux_dmabuf_v1_shim();
void set_zwp_linux_dmabuf_v1_shim (ZwpLinuxDmabufV1Shim* shim);

class ZwpLinuxBufferParamsV1Shim {
  public:
    ZwpLinuxBufferParamsV1Shim() = default;
    ZwpLinuxBufferParamsV1Shim(ZwpLinuxBufferParamsV1Shim&&) = delete;
    ZwpLinuxBufferParamsV1Shim& operator=(ZwpLinuxBufferParamsV1Shim&&) = delete;
    virtual ~ZwpLinuxBufferParamsV1Shim() = default;

    virtual void set_user_data(struct zwp_linux_buffer_params_v1* zwp_linux_buffer_params_v1, void* user_data);

    virtual void* get_user_data(struct zwp_linux_buffer_params_v1* zwp_linux_buffer_params_v1);
    virtual int add_listener(struct zwp_linux_buffer_params_v1* zwp_linux_buffer_params_v1, const struct zwp_linux_buffer_params_v1_listener* listener, void* data);
    
    virtual void destroy(
        struct zwp_linux_buffer_params_v1 *zwp_linux_buffer_params_v1);
    
    virtual void add(
        struct zwp_linux_buffer_params_v1 *zwp_linux_buffer_params_v1,
        int32_t fd,
        uint32_t plane_idx,
        uint32_t offset,
        uint32_t stride,
        uint32_t modifier_hi,
        uint32_t modifier_lo);
    
    virtual void create(
        struct zwp_linux_buffer_params_v1 *zwp_linux_buffer_params_v1,
        int32_t width,
        int32_t height,
        uint32_t format,
        uint32_t flags);
    
    virtual struct wl_buffer* create_immed(
        struct zwp_linux_buffer_params_v1 *zwp_linux_buffer_params_v1,
        int32_t width,
        int32_t height,
        uint32_t format,
        uint32_t flags);
    
    virtual void send_created(
        struct wl_resource* resource,
        struct wl_resource * buffer);
    
    virtual void send_failed(
        struct wl_resource* resource);
    };

ZwpLinuxBufferParamsV1Shim* zwp_linux_buffer_params_v1_shim();
void set_zwp_linux_buffer_params_v1_shim (ZwpLinuxBufferParamsV1Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_LINUX_DMABUF_UNSTABLE_V1_SHIM_H_