// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_LINUX_EXPLICIT_SYNCHRONIZATION_UNSTABLE_V1_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_LINUX_EXPLICIT_SYNCHRONIZATION_UNSTABLE_V1_SHIM_H_

#include "linux-explicit-synchronization-unstable-v1-client-protocol.h"  // NOLINT(build/include_directory)
#include "linux-explicit-synchronization-unstable-v1-server-protocol.h"  // NOLINT(build/include_directory)


class ZwpLinuxExplicitSynchronizationV1Shim {
  public:
    ZwpLinuxExplicitSynchronizationV1Shim() = default;
    ZwpLinuxExplicitSynchronizationV1Shim(ZwpLinuxExplicitSynchronizationV1Shim&&) = delete;
    ZwpLinuxExplicitSynchronizationV1Shim& operator=(ZwpLinuxExplicitSynchronizationV1Shim&&) = delete;
    virtual ~ZwpLinuxExplicitSynchronizationV1Shim() = default;

    virtual void set_user_data(struct zwp_linux_explicit_synchronization_v1* zwp_linux_explicit_synchronization_v1, void* user_data);

    virtual void* get_user_data(struct zwp_linux_explicit_synchronization_v1* zwp_linux_explicit_synchronization_v1);
    virtual void destroy(
        struct zwp_linux_explicit_synchronization_v1 *zwp_linux_explicit_synchronization_v1);
    
    virtual struct zwp_linux_surface_synchronization_v1* get_synchronization(
        struct zwp_linux_explicit_synchronization_v1 *zwp_linux_explicit_synchronization_v1,
        struct wl_surface* surface);
    };

ZwpLinuxExplicitSynchronizationV1Shim* zwp_linux_explicit_synchronization_v1_shim();
void set_zwp_linux_explicit_synchronization_v1_shim (ZwpLinuxExplicitSynchronizationV1Shim* shim);

class ZwpLinuxSurfaceSynchronizationV1Shim {
  public:
    ZwpLinuxSurfaceSynchronizationV1Shim() = default;
    ZwpLinuxSurfaceSynchronizationV1Shim(ZwpLinuxSurfaceSynchronizationV1Shim&&) = delete;
    ZwpLinuxSurfaceSynchronizationV1Shim& operator=(ZwpLinuxSurfaceSynchronizationV1Shim&&) = delete;
    virtual ~ZwpLinuxSurfaceSynchronizationV1Shim() = default;

    virtual void set_user_data(struct zwp_linux_surface_synchronization_v1* zwp_linux_surface_synchronization_v1, void* user_data);

    virtual void* get_user_data(struct zwp_linux_surface_synchronization_v1* zwp_linux_surface_synchronization_v1);
    virtual void destroy(
        struct zwp_linux_surface_synchronization_v1 *zwp_linux_surface_synchronization_v1);
    
    virtual void set_acquire_fence(
        struct zwp_linux_surface_synchronization_v1 *zwp_linux_surface_synchronization_v1,
        int32_t fd);
    
    virtual struct zwp_linux_buffer_release_v1* get_release(
        struct zwp_linux_surface_synchronization_v1 *zwp_linux_surface_synchronization_v1);
    };

ZwpLinuxSurfaceSynchronizationV1Shim* zwp_linux_surface_synchronization_v1_shim();
void set_zwp_linux_surface_synchronization_v1_shim (ZwpLinuxSurfaceSynchronizationV1Shim* shim);

class ZwpLinuxBufferReleaseV1Shim {
  public:
    ZwpLinuxBufferReleaseV1Shim() = default;
    ZwpLinuxBufferReleaseV1Shim(ZwpLinuxBufferReleaseV1Shim&&) = delete;
    ZwpLinuxBufferReleaseV1Shim& operator=(ZwpLinuxBufferReleaseV1Shim&&) = delete;
    virtual ~ZwpLinuxBufferReleaseV1Shim() = default;

    virtual void set_user_data(struct zwp_linux_buffer_release_v1* zwp_linux_buffer_release_v1, void* user_data);

    virtual void* get_user_data(struct zwp_linux_buffer_release_v1* zwp_linux_buffer_release_v1);
    virtual int add_listener(struct zwp_linux_buffer_release_v1* zwp_linux_buffer_release_v1, const struct zwp_linux_buffer_release_v1_listener* listener, void* data);
    
    virtual void send_fenced_release(
        struct wl_resource* resource,
        int32_t fence);
    
    virtual void send_immediate_release(
        struct wl_resource* resource);
    };

ZwpLinuxBufferReleaseV1Shim* zwp_linux_buffer_release_v1_shim();
void set_zwp_linux_buffer_release_v1_shim (ZwpLinuxBufferReleaseV1Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_LINUX_EXPLICIT_SYNCHRONIZATION_UNSTABLE_V1_SHIM_H_