// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_MOCK_XDG_SHELL_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_MOCK_XDG_SHELL_SHIM_H_

#include <gmock/gmock.h>

#include "xdg-shell-shim.h"
class MockXdgWmBaseShim : public XdgWmBaseShim {
  public:
    MOCK_METHOD(void, set_user_data, (struct xdg_wm_base* xdg_wm_base, void* user_data), (override));
    MOCK_METHOD(void*, get_user_data, (struct xdg_wm_base* xdg_wm_base), (override));
    MOCK_METHOD(int, add_listener, (struct xdg_wm_base* xdg_wm_base, const struct xdg_wm_base_listener* listener, void* data), (override));
    
    MOCK_METHOD(void, destroy, (struct xdg_wm_base* xdg_wm_base), (override));
  
    MOCK_METHOD(struct xdg_positioner*, create_positioner, (struct xdg_wm_base* xdg_wm_base), (override));
  
    MOCK_METHOD(struct xdg_surface*, get_xdg_surface, (struct xdg_wm_base* xdg_wm_base, struct wl_surface* surface), (override));
  
    MOCK_METHOD(void, pong, (struct xdg_wm_base* xdg_wm_base, uint32_t serial), (override));
  
    MOCK_METHOD(void, send_ping, (struct wl_resource* resource, uint32_t serial), (override));
  };

class MockXdgPositionerShim : public XdgPositionerShim {
  public:
    MOCK_METHOD(void, set_user_data, (struct xdg_positioner* xdg_positioner, void* user_data), (override));
    MOCK_METHOD(void*, get_user_data, (struct xdg_positioner* xdg_positioner), (override));
    MOCK_METHOD(void, destroy, (struct xdg_positioner* xdg_positioner), (override));
  
    MOCK_METHOD(void, set_size, (struct xdg_positioner* xdg_positioner, int32_t width, int32_t height), (override));
  
    MOCK_METHOD(void, set_anchor_rect, (struct xdg_positioner* xdg_positioner, int32_t x, int32_t y, int32_t width, int32_t height), (override));
  
    MOCK_METHOD(void, set_anchor, (struct xdg_positioner* xdg_positioner, uint32_t anchor), (override));
  
    MOCK_METHOD(void, set_gravity, (struct xdg_positioner* xdg_positioner, uint32_t gravity), (override));
  
    MOCK_METHOD(void, set_constraint_adjustment, (struct xdg_positioner* xdg_positioner, uint32_t constraint_adjustment), (override));
  
    MOCK_METHOD(void, set_offset, (struct xdg_positioner* xdg_positioner, int32_t x, int32_t y), (override));
  
    MOCK_METHOD(void, set_reactive, (struct xdg_positioner* xdg_positioner), (override));
  
    MOCK_METHOD(void, set_parent_size, (struct xdg_positioner* xdg_positioner, int32_t parent_width, int32_t parent_height), (override));
  
    MOCK_METHOD(void, set_parent_configure, (struct xdg_positioner* xdg_positioner, uint32_t serial), (override));
  };

class MockXdgSurfaceShim : public XdgSurfaceShim {
  public:
    MOCK_METHOD(void, set_user_data, (struct xdg_surface* xdg_surface, void* user_data), (override));
    MOCK_METHOD(void*, get_user_data, (struct xdg_surface* xdg_surface), (override));
    MOCK_METHOD(int, add_listener, (struct xdg_surface* xdg_surface, const struct xdg_surface_listener* listener, void* data), (override));
    
    MOCK_METHOD(void, destroy, (struct xdg_surface* xdg_surface), (override));
  
    MOCK_METHOD(struct xdg_toplevel*, get_toplevel, (struct xdg_surface* xdg_surface), (override));
  
    MOCK_METHOD(struct xdg_popup*, get_popup, (struct xdg_surface* xdg_surface, struct xdg_surface* parent, struct xdg_positioner* positioner), (override));
  
    MOCK_METHOD(void, set_window_geometry, (struct xdg_surface* xdg_surface, int32_t x, int32_t y, int32_t width, int32_t height), (override));
  
    MOCK_METHOD(void, ack_configure, (struct xdg_surface* xdg_surface, uint32_t serial), (override));
  
    MOCK_METHOD(void, send_configure, (struct wl_resource* resource, uint32_t serial), (override));
  };

class MockXdgToplevelShim : public XdgToplevelShim {
  public:
    MOCK_METHOD(void, set_user_data, (struct xdg_toplevel* xdg_toplevel, void* user_data), (override));
    MOCK_METHOD(void*, get_user_data, (struct xdg_toplevel* xdg_toplevel), (override));
    MOCK_METHOD(int, add_listener, (struct xdg_toplevel* xdg_toplevel, const struct xdg_toplevel_listener* listener, void* data), (override));
    
    MOCK_METHOD(void, destroy, (struct xdg_toplevel* xdg_toplevel), (override));
  
    MOCK_METHOD(void, set_parent, (struct xdg_toplevel* xdg_toplevel, struct xdg_toplevel* parent), (override));
  
    MOCK_METHOD(void, set_title, (struct xdg_toplevel* xdg_toplevel, const char * title), (override));
  
    MOCK_METHOD(void, set_app_id, (struct xdg_toplevel* xdg_toplevel, const char * app_id), (override));
  
    MOCK_METHOD(void, show_window_menu, (struct xdg_toplevel* xdg_toplevel, struct wl_seat* seat, uint32_t serial, int32_t x, int32_t y), (override));
  
    MOCK_METHOD(void, move, (struct xdg_toplevel* xdg_toplevel, struct wl_seat* seat, uint32_t serial), (override));
  
    MOCK_METHOD(void, resize, (struct xdg_toplevel* xdg_toplevel, struct wl_seat* seat, uint32_t serial, uint32_t edges), (override));
  
    MOCK_METHOD(void, set_max_size, (struct xdg_toplevel* xdg_toplevel, int32_t width, int32_t height), (override));
  
    MOCK_METHOD(void, set_min_size, (struct xdg_toplevel* xdg_toplevel, int32_t width, int32_t height), (override));
  
    MOCK_METHOD(void, set_maximized, (struct xdg_toplevel* xdg_toplevel), (override));
  
    MOCK_METHOD(void, unset_maximized, (struct xdg_toplevel* xdg_toplevel), (override));
  
    MOCK_METHOD(void, set_fullscreen, (struct xdg_toplevel* xdg_toplevel, struct wl_output* output), (override));
  
    MOCK_METHOD(void, unset_fullscreen, (struct xdg_toplevel* xdg_toplevel), (override));
  
    MOCK_METHOD(void, set_minimized, (struct xdg_toplevel* xdg_toplevel), (override));
  
    MOCK_METHOD(void, send_configure, (struct wl_resource* resource, int32_t width, int32_t height, struct wl_array* states), (override));
  
    MOCK_METHOD(void, send_close, (struct wl_resource* resource), (override));
  };

class MockXdgPopupShim : public XdgPopupShim {
  public:
    MOCK_METHOD(void, set_user_data, (struct xdg_popup* xdg_popup, void* user_data), (override));
    MOCK_METHOD(void*, get_user_data, (struct xdg_popup* xdg_popup), (override));
    MOCK_METHOD(int, add_listener, (struct xdg_popup* xdg_popup, const struct xdg_popup_listener* listener, void* data), (override));
    
    MOCK_METHOD(void, destroy, (struct xdg_popup* xdg_popup), (override));
  
    MOCK_METHOD(void, grab, (struct xdg_popup* xdg_popup, struct wl_seat* seat, uint32_t serial), (override));
  
    MOCK_METHOD(void, reposition, (struct xdg_popup* xdg_popup, struct xdg_positioner* positioner, uint32_t token), (override));
  
    MOCK_METHOD(void, send_configure, (struct wl_resource* resource, int32_t x, int32_t y, int32_t width, int32_t height), (override));
  
    MOCK_METHOD(void, send_popup_done, (struct wl_resource* resource), (override));
  
    MOCK_METHOD(void, send_repositioned, (struct wl_resource* resource, uint32_t token), (override));
  };
#endif // VM_TOOLS_SOMMELIER_GEN_MOCK_XDG_SHELL_SHIM_H_