// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_POINTER_CONSTRAINTS_UNSTABLE_V1_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_POINTER_CONSTRAINTS_UNSTABLE_V1_SHIM_H_

#include "pointer-constraints-unstable-v1-client-protocol.h"  // NOLINT(build/include_directory)
#include "pointer-constraints-unstable-v1-server-protocol.h"  // NOLINT(build/include_directory)


class ZwpPointerConstraintsV1Shim {
  public:
    ZwpPointerConstraintsV1Shim() = default;
    ZwpPointerConstraintsV1Shim(ZwpPointerConstraintsV1Shim&&) = delete;
    ZwpPointerConstraintsV1Shim& operator=(ZwpPointerConstraintsV1Shim&&) = delete;
    virtual ~ZwpPointerConstraintsV1Shim() = default;

    virtual void set_user_data(struct zwp_pointer_constraints_v1* zwp_pointer_constraints_v1, void* user_data);

    virtual void* get_user_data(struct zwp_pointer_constraints_v1* zwp_pointer_constraints_v1);
    virtual void destroy(
        struct zwp_pointer_constraints_v1 *zwp_pointer_constraints_v1);
    
    virtual struct zwp_locked_pointer_v1* lock_pointer(
        struct zwp_pointer_constraints_v1 *zwp_pointer_constraints_v1,
        struct wl_surface* surface,
        struct wl_pointer* pointer,
        struct wl_region* region,
        uint32_t lifetime);
    
    virtual struct zwp_confined_pointer_v1* confine_pointer(
        struct zwp_pointer_constraints_v1 *zwp_pointer_constraints_v1,
        struct wl_surface* surface,
        struct wl_pointer* pointer,
        struct wl_region* region,
        uint32_t lifetime);
    };

ZwpPointerConstraintsV1Shim* zwp_pointer_constraints_v1_shim();
void set_zwp_pointer_constraints_v1_shim (ZwpPointerConstraintsV1Shim* shim);

class ZwpLockedPointerV1Shim {
  public:
    ZwpLockedPointerV1Shim() = default;
    ZwpLockedPointerV1Shim(ZwpLockedPointerV1Shim&&) = delete;
    ZwpLockedPointerV1Shim& operator=(ZwpLockedPointerV1Shim&&) = delete;
    virtual ~ZwpLockedPointerV1Shim() = default;

    virtual void set_user_data(struct zwp_locked_pointer_v1* zwp_locked_pointer_v1, void* user_data);

    virtual void* get_user_data(struct zwp_locked_pointer_v1* zwp_locked_pointer_v1);
    virtual int add_listener(struct zwp_locked_pointer_v1* zwp_locked_pointer_v1, const struct zwp_locked_pointer_v1_listener* listener, void* data);
    
    virtual void destroy(
        struct zwp_locked_pointer_v1 *zwp_locked_pointer_v1);
    
    virtual void set_cursor_position_hint(
        struct zwp_locked_pointer_v1 *zwp_locked_pointer_v1,
        wl_fixed_t surface_x,
        wl_fixed_t surface_y);
    
    virtual void set_region(
        struct zwp_locked_pointer_v1 *zwp_locked_pointer_v1,
        struct wl_region* region);
    
    virtual void send_locked(
        struct wl_resource* resource);
    
    virtual void send_unlocked(
        struct wl_resource* resource);
    };

ZwpLockedPointerV1Shim* zwp_locked_pointer_v1_shim();
void set_zwp_locked_pointer_v1_shim (ZwpLockedPointerV1Shim* shim);

class ZwpConfinedPointerV1Shim {
  public:
    ZwpConfinedPointerV1Shim() = default;
    ZwpConfinedPointerV1Shim(ZwpConfinedPointerV1Shim&&) = delete;
    ZwpConfinedPointerV1Shim& operator=(ZwpConfinedPointerV1Shim&&) = delete;
    virtual ~ZwpConfinedPointerV1Shim() = default;

    virtual void set_user_data(struct zwp_confined_pointer_v1* zwp_confined_pointer_v1, void* user_data);

    virtual void* get_user_data(struct zwp_confined_pointer_v1* zwp_confined_pointer_v1);
    virtual int add_listener(struct zwp_confined_pointer_v1* zwp_confined_pointer_v1, const struct zwp_confined_pointer_v1_listener* listener, void* data);
    
    virtual void destroy(
        struct zwp_confined_pointer_v1 *zwp_confined_pointer_v1);
    
    virtual void set_region(
        struct zwp_confined_pointer_v1 *zwp_confined_pointer_v1,
        struct wl_region* region);
    
    virtual void send_confined(
        struct wl_resource* resource);
    
    virtual void send_unconfined(
        struct wl_resource* resource);
    };

ZwpConfinedPointerV1Shim* zwp_confined_pointer_v1_shim();
void set_zwp_confined_pointer_v1_shim (ZwpConfinedPointerV1Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_POINTER_CONSTRAINTS_UNSTABLE_V1_SHIM_H_