// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_STYLUS_UNSTABLE_V2_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_STYLUS_UNSTABLE_V2_SHIM_H_

#include "stylus-unstable-v2-client-protocol.h"  // NOLINT(build/include_directory)
#include "stylus-unstable-v2-server-protocol.h"  // NOLINT(build/include_directory)


class ZcrStylusV2Shim {
  public:
    ZcrStylusV2Shim() = default;
    ZcrStylusV2Shim(ZcrStylusV2Shim&&) = delete;
    ZcrStylusV2Shim& operator=(ZcrStylusV2Shim&&) = delete;
    virtual ~ZcrStylusV2Shim() = default;

    virtual void set_user_data(struct zcr_stylus_v2* zcr_stylus_v2, void* user_data);

    virtual void* get_user_data(struct zcr_stylus_v2* zcr_stylus_v2);
    virtual struct zcr_touch_stylus_v2* get_touch_stylus(
        struct zcr_stylus_v2 *zcr_stylus_v2,
        struct wl_touch* touch);
    
    virtual struct zcr_pointer_stylus_v2* get_pointer_stylus(
        struct zcr_stylus_v2 *zcr_stylus_v2,
        struct wl_pointer* pointer);
    };

ZcrStylusV2Shim* zcr_stylus_v2_shim();
void set_zcr_stylus_v2_shim (ZcrStylusV2Shim* shim);

class ZcrTouchStylusV2Shim {
  public:
    ZcrTouchStylusV2Shim() = default;
    ZcrTouchStylusV2Shim(ZcrTouchStylusV2Shim&&) = delete;
    ZcrTouchStylusV2Shim& operator=(ZcrTouchStylusV2Shim&&) = delete;
    virtual ~ZcrTouchStylusV2Shim() = default;

    virtual void set_user_data(struct zcr_touch_stylus_v2* zcr_touch_stylus_v2, void* user_data);

    virtual void* get_user_data(struct zcr_touch_stylus_v2* zcr_touch_stylus_v2);
    virtual int add_listener(struct zcr_touch_stylus_v2* zcr_touch_stylus_v2, const struct zcr_touch_stylus_v2_listener* listener, void* data);
    
    virtual void destroy(
        struct zcr_touch_stylus_v2 *zcr_touch_stylus_v2);
    
    virtual void send_tool(
        struct wl_resource* resource,
        uint32_t id,
        uint32_t type);
    
    virtual void send_force(
        struct wl_resource* resource,
        uint32_t time,
        uint32_t id,
        wl_fixed_t force);
    
    virtual void send_tilt(
        struct wl_resource* resource,
        uint32_t time,
        uint32_t id,
        wl_fixed_t tilt_x,
        wl_fixed_t tilt_y);
    };

ZcrTouchStylusV2Shim* zcr_touch_stylus_v2_shim();
void set_zcr_touch_stylus_v2_shim (ZcrTouchStylusV2Shim* shim);

class ZcrPointerStylusV2Shim {
  public:
    ZcrPointerStylusV2Shim() = default;
    ZcrPointerStylusV2Shim(ZcrPointerStylusV2Shim&&) = delete;
    ZcrPointerStylusV2Shim& operator=(ZcrPointerStylusV2Shim&&) = delete;
    virtual ~ZcrPointerStylusV2Shim() = default;

    virtual void set_user_data(struct zcr_pointer_stylus_v2* zcr_pointer_stylus_v2, void* user_data);

    virtual void* get_user_data(struct zcr_pointer_stylus_v2* zcr_pointer_stylus_v2);
    virtual int add_listener(struct zcr_pointer_stylus_v2* zcr_pointer_stylus_v2, const struct zcr_pointer_stylus_v2_listener* listener, void* data);
    
    virtual void destroy(
        struct zcr_pointer_stylus_v2 *zcr_pointer_stylus_v2);
    
    virtual void send_tool(
        struct wl_resource* resource,
        uint32_t type);
    
    virtual void send_force(
        struct wl_resource* resource,
        uint32_t time,
        wl_fixed_t force);
    
    virtual void send_tilt(
        struct wl_resource* resource,
        uint32_t time,
        wl_fixed_t tilt_x,
        wl_fixed_t tilt_y);
    };

ZcrPointerStylusV2Shim* zcr_pointer_stylus_v2_shim();
void set_zcr_pointer_stylus_v2_shim (ZcrPointerStylusV2Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_STYLUS_UNSTABLE_V2_SHIM_H_