// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_TABLET_UNSTABLE_V2_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_TABLET_UNSTABLE_V2_SHIM_H_

#include "tablet-unstable-v2-client-protocol.h"  // NOLINT(build/include_directory)
#include "tablet-unstable-v2-server-protocol.h"  // NOLINT(build/include_directory)


class ZwpTabletManagerV2Shim {
  public:
    ZwpTabletManagerV2Shim() = default;
    ZwpTabletManagerV2Shim(ZwpTabletManagerV2Shim&&) = delete;
    ZwpTabletManagerV2Shim& operator=(ZwpTabletManagerV2Shim&&) = delete;
    virtual ~ZwpTabletManagerV2Shim() = default;

    virtual void set_user_data(struct zwp_tablet_manager_v2* zwp_tablet_manager_v2, void* user_data);

    virtual void* get_user_data(struct zwp_tablet_manager_v2* zwp_tablet_manager_v2);
    virtual struct zwp_tablet_seat_v2* get_tablet_seat(
        struct zwp_tablet_manager_v2 *zwp_tablet_manager_v2,
        struct wl_seat* seat);
    
    virtual void destroy(
        struct zwp_tablet_manager_v2 *zwp_tablet_manager_v2);
    };

ZwpTabletManagerV2Shim* zwp_tablet_manager_v2_shim();
void set_zwp_tablet_manager_v2_shim (ZwpTabletManagerV2Shim* shim);

class ZwpTabletSeatV2Shim {
  public:
    ZwpTabletSeatV2Shim() = default;
    ZwpTabletSeatV2Shim(ZwpTabletSeatV2Shim&&) = delete;
    ZwpTabletSeatV2Shim& operator=(ZwpTabletSeatV2Shim&&) = delete;
    virtual ~ZwpTabletSeatV2Shim() = default;

    virtual void set_user_data(struct zwp_tablet_seat_v2* zwp_tablet_seat_v2, void* user_data);

    virtual void* get_user_data(struct zwp_tablet_seat_v2* zwp_tablet_seat_v2);
    virtual int add_listener(struct zwp_tablet_seat_v2* zwp_tablet_seat_v2, const struct zwp_tablet_seat_v2_listener* listener, void* data);
    
    virtual void destroy(
        struct zwp_tablet_seat_v2 *zwp_tablet_seat_v2);
    
    virtual void send_tablet_added(
        struct wl_resource* resource,
        struct wl_resource * id);
    
    virtual void send_tool_added(
        struct wl_resource* resource,
        struct wl_resource * id);
    
    virtual void send_pad_added(
        struct wl_resource* resource,
        struct wl_resource * id);
    };

ZwpTabletSeatV2Shim* zwp_tablet_seat_v2_shim();
void set_zwp_tablet_seat_v2_shim (ZwpTabletSeatV2Shim* shim);

class ZwpTabletToolV2Shim {
  public:
    ZwpTabletToolV2Shim() = default;
    ZwpTabletToolV2Shim(ZwpTabletToolV2Shim&&) = delete;
    ZwpTabletToolV2Shim& operator=(ZwpTabletToolV2Shim&&) = delete;
    virtual ~ZwpTabletToolV2Shim() = default;

    virtual void set_user_data(struct zwp_tablet_tool_v2* zwp_tablet_tool_v2, void* user_data);

    virtual void* get_user_data(struct zwp_tablet_tool_v2* zwp_tablet_tool_v2);
    virtual int add_listener(struct zwp_tablet_tool_v2* zwp_tablet_tool_v2, const struct zwp_tablet_tool_v2_listener* listener, void* data);
    
    virtual void set_cursor(
        struct zwp_tablet_tool_v2 *zwp_tablet_tool_v2,
        uint32_t serial,
        struct wl_surface* surface,
        int32_t hotspot_x,
        int32_t hotspot_y);
    
    virtual void destroy(
        struct zwp_tablet_tool_v2 *zwp_tablet_tool_v2);
    
    virtual void send_type(
        struct wl_resource* resource,
        uint32_t tool_type);
    
    virtual void send_hardware_serial(
        struct wl_resource* resource,
        uint32_t hardware_serial_hi,
        uint32_t hardware_serial_lo);
    
    virtual void send_hardware_id_wacom(
        struct wl_resource* resource,
        uint32_t hardware_id_hi,
        uint32_t hardware_id_lo);
    
    virtual void send_capability(
        struct wl_resource* resource,
        uint32_t capability);
    
    virtual void send_done(
        struct wl_resource* resource);
    
    virtual void send_removed(
        struct wl_resource* resource);
    
    virtual void send_proximity_in(
        struct wl_resource* resource,
        uint32_t serial,
        struct wl_resource * tablet,
        struct wl_resource * surface);
    
    virtual void send_proximity_out(
        struct wl_resource* resource);
    
    virtual void send_down(
        struct wl_resource* resource,
        uint32_t serial);
    
    virtual void send_up(
        struct wl_resource* resource);
    
    virtual void send_motion(
        struct wl_resource* resource,
        wl_fixed_t x,
        wl_fixed_t y);
    
    virtual void send_pressure(
        struct wl_resource* resource,
        uint32_t pressure);
    
    virtual void send_distance(
        struct wl_resource* resource,
        uint32_t distance);
    
    virtual void send_tilt(
        struct wl_resource* resource,
        wl_fixed_t tilt_x,
        wl_fixed_t tilt_y);
    
    virtual void send_rotation(
        struct wl_resource* resource,
        wl_fixed_t degrees);
    
    virtual void send_slider(
        struct wl_resource* resource,
        int32_t position);
    
    virtual void send_wheel(
        struct wl_resource* resource,
        wl_fixed_t degrees,
        int32_t clicks);
    
    virtual void send_button(
        struct wl_resource* resource,
        uint32_t serial,
        uint32_t button,
        uint32_t state);
    
    virtual void send_frame(
        struct wl_resource* resource,
        uint32_t time);
    };

ZwpTabletToolV2Shim* zwp_tablet_tool_v2_shim();
void set_zwp_tablet_tool_v2_shim (ZwpTabletToolV2Shim* shim);

class ZwpTabletV2Shim {
  public:
    ZwpTabletV2Shim() = default;
    ZwpTabletV2Shim(ZwpTabletV2Shim&&) = delete;
    ZwpTabletV2Shim& operator=(ZwpTabletV2Shim&&) = delete;
    virtual ~ZwpTabletV2Shim() = default;

    virtual void set_user_data(struct zwp_tablet_v2* zwp_tablet_v2, void* user_data);

    virtual void* get_user_data(struct zwp_tablet_v2* zwp_tablet_v2);
    virtual int add_listener(struct zwp_tablet_v2* zwp_tablet_v2, const struct zwp_tablet_v2_listener* listener, void* data);
    
    virtual void destroy(
        struct zwp_tablet_v2 *zwp_tablet_v2);
    
    virtual void send_name(
        struct wl_resource* resource,
        const char * name);
    
    virtual void send_id(
        struct wl_resource* resource,
        uint32_t vid,
        uint32_t pid);
    
    virtual void send_path(
        struct wl_resource* resource,
        const char * path);
    
    virtual void send_done(
        struct wl_resource* resource);
    
    virtual void send_removed(
        struct wl_resource* resource);
    };

ZwpTabletV2Shim* zwp_tablet_v2_shim();
void set_zwp_tablet_v2_shim (ZwpTabletV2Shim* shim);

class ZwpTabletPadRingV2Shim {
  public:
    ZwpTabletPadRingV2Shim() = default;
    ZwpTabletPadRingV2Shim(ZwpTabletPadRingV2Shim&&) = delete;
    ZwpTabletPadRingV2Shim& operator=(ZwpTabletPadRingV2Shim&&) = delete;
    virtual ~ZwpTabletPadRingV2Shim() = default;

    virtual void set_user_data(struct zwp_tablet_pad_ring_v2* zwp_tablet_pad_ring_v2, void* user_data);

    virtual void* get_user_data(struct zwp_tablet_pad_ring_v2* zwp_tablet_pad_ring_v2);
    virtual int add_listener(struct zwp_tablet_pad_ring_v2* zwp_tablet_pad_ring_v2, const struct zwp_tablet_pad_ring_v2_listener* listener, void* data);
    
    virtual void set_feedback(
        struct zwp_tablet_pad_ring_v2 *zwp_tablet_pad_ring_v2,
        const char * description,
        uint32_t serial);
    
    virtual void destroy(
        struct zwp_tablet_pad_ring_v2 *zwp_tablet_pad_ring_v2);
    
    virtual void send_source(
        struct wl_resource* resource,
        uint32_t source);
    
    virtual void send_angle(
        struct wl_resource* resource,
        wl_fixed_t degrees);
    
    virtual void send_stop(
        struct wl_resource* resource);
    
    virtual void send_frame(
        struct wl_resource* resource,
        uint32_t time);
    };

ZwpTabletPadRingV2Shim* zwp_tablet_pad_ring_v2_shim();
void set_zwp_tablet_pad_ring_v2_shim (ZwpTabletPadRingV2Shim* shim);

class ZwpTabletPadStripV2Shim {
  public:
    ZwpTabletPadStripV2Shim() = default;
    ZwpTabletPadStripV2Shim(ZwpTabletPadStripV2Shim&&) = delete;
    ZwpTabletPadStripV2Shim& operator=(ZwpTabletPadStripV2Shim&&) = delete;
    virtual ~ZwpTabletPadStripV2Shim() = default;

    virtual void set_user_data(struct zwp_tablet_pad_strip_v2* zwp_tablet_pad_strip_v2, void* user_data);

    virtual void* get_user_data(struct zwp_tablet_pad_strip_v2* zwp_tablet_pad_strip_v2);
    virtual int add_listener(struct zwp_tablet_pad_strip_v2* zwp_tablet_pad_strip_v2, const struct zwp_tablet_pad_strip_v2_listener* listener, void* data);
    
    virtual void set_feedback(
        struct zwp_tablet_pad_strip_v2 *zwp_tablet_pad_strip_v2,
        const char * description,
        uint32_t serial);
    
    virtual void destroy(
        struct zwp_tablet_pad_strip_v2 *zwp_tablet_pad_strip_v2);
    
    virtual void send_source(
        struct wl_resource* resource,
        uint32_t source);
    
    virtual void send_position(
        struct wl_resource* resource,
        uint32_t position);
    
    virtual void send_stop(
        struct wl_resource* resource);
    
    virtual void send_frame(
        struct wl_resource* resource,
        uint32_t time);
    };

ZwpTabletPadStripV2Shim* zwp_tablet_pad_strip_v2_shim();
void set_zwp_tablet_pad_strip_v2_shim (ZwpTabletPadStripV2Shim* shim);

class ZwpTabletPadGroupV2Shim {
  public:
    ZwpTabletPadGroupV2Shim() = default;
    ZwpTabletPadGroupV2Shim(ZwpTabletPadGroupV2Shim&&) = delete;
    ZwpTabletPadGroupV2Shim& operator=(ZwpTabletPadGroupV2Shim&&) = delete;
    virtual ~ZwpTabletPadGroupV2Shim() = default;

    virtual void set_user_data(struct zwp_tablet_pad_group_v2* zwp_tablet_pad_group_v2, void* user_data);

    virtual void* get_user_data(struct zwp_tablet_pad_group_v2* zwp_tablet_pad_group_v2);
    virtual int add_listener(struct zwp_tablet_pad_group_v2* zwp_tablet_pad_group_v2, const struct zwp_tablet_pad_group_v2_listener* listener, void* data);
    
    virtual void destroy(
        struct zwp_tablet_pad_group_v2 *zwp_tablet_pad_group_v2);
    
    virtual void send_buttons(
        struct wl_resource* resource,
        struct wl_array* buttons);
    
    virtual void send_ring(
        struct wl_resource* resource,
        struct wl_resource * ring);
    
    virtual void send_strip(
        struct wl_resource* resource,
        struct wl_resource * strip);
    
    virtual void send_modes(
        struct wl_resource* resource,
        uint32_t modes);
    
    virtual void send_done(
        struct wl_resource* resource);
    
    virtual void send_mode_switch(
        struct wl_resource* resource,
        uint32_t time,
        uint32_t serial,
        uint32_t mode);
    };

ZwpTabletPadGroupV2Shim* zwp_tablet_pad_group_v2_shim();
void set_zwp_tablet_pad_group_v2_shim (ZwpTabletPadGroupV2Shim* shim);

class ZwpTabletPadV2Shim {
  public:
    ZwpTabletPadV2Shim() = default;
    ZwpTabletPadV2Shim(ZwpTabletPadV2Shim&&) = delete;
    ZwpTabletPadV2Shim& operator=(ZwpTabletPadV2Shim&&) = delete;
    virtual ~ZwpTabletPadV2Shim() = default;

    virtual void set_user_data(struct zwp_tablet_pad_v2* zwp_tablet_pad_v2, void* user_data);

    virtual void* get_user_data(struct zwp_tablet_pad_v2* zwp_tablet_pad_v2);
    virtual int add_listener(struct zwp_tablet_pad_v2* zwp_tablet_pad_v2, const struct zwp_tablet_pad_v2_listener* listener, void* data);
    
    virtual void set_feedback(
        struct zwp_tablet_pad_v2 *zwp_tablet_pad_v2,
        uint32_t button,
        const char * description,
        uint32_t serial);
    
    virtual void destroy(
        struct zwp_tablet_pad_v2 *zwp_tablet_pad_v2);
    
    virtual void send_group(
        struct wl_resource* resource,
        struct wl_resource * pad_group);
    
    virtual void send_path(
        struct wl_resource* resource,
        const char * path);
    
    virtual void send_buttons(
        struct wl_resource* resource,
        uint32_t buttons);
    
    virtual void send_done(
        struct wl_resource* resource);
    
    virtual void send_button(
        struct wl_resource* resource,
        uint32_t time,
        uint32_t button,
        uint32_t state);
    
    virtual void send_enter(
        struct wl_resource* resource,
        uint32_t serial,
        struct wl_resource * tablet,
        struct wl_resource * surface);
    
    virtual void send_leave(
        struct wl_resource* resource,
        uint32_t serial,
        struct wl_resource * surface);
    
    virtual void send_removed(
        struct wl_resource* resource);
    };

ZwpTabletPadV2Shim* zwp_tablet_pad_v2_shim();
void set_zwp_tablet_pad_v2_shim (ZwpTabletPadV2Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_TABLET_UNSTABLE_V2_SHIM_H_