// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_TEXT_INPUT_EXTENSION_UNSTABLE_V1_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_TEXT_INPUT_EXTENSION_UNSTABLE_V1_SHIM_H_

#include "text-input-extension-unstable-v1-client-protocol.h"  // NOLINT(build/include_directory)
#include "text-input-extension-unstable-v1-server-protocol.h"  // NOLINT(build/include_directory)


class ZcrTextInputExtensionV1Shim {
  public:
    ZcrTextInputExtensionV1Shim() = default;
    ZcrTextInputExtensionV1Shim(ZcrTextInputExtensionV1Shim&&) = delete;
    ZcrTextInputExtensionV1Shim& operator=(ZcrTextInputExtensionV1Shim&&) = delete;
    virtual ~ZcrTextInputExtensionV1Shim() = default;

    virtual void set_user_data(struct zcr_text_input_extension_v1* zcr_text_input_extension_v1, void* user_data);

    virtual void* get_user_data(struct zcr_text_input_extension_v1* zcr_text_input_extension_v1);
    virtual struct zcr_extended_text_input_v1* get_extended_text_input(
        struct zcr_text_input_extension_v1 *zcr_text_input_extension_v1,
        struct zwp_text_input_v1* text_input);
    };

ZcrTextInputExtensionV1Shim* zcr_text_input_extension_v1_shim();
void set_zcr_text_input_extension_v1_shim (ZcrTextInputExtensionV1Shim* shim);

class ZcrExtendedTextInputV1Shim {
  public:
    ZcrExtendedTextInputV1Shim() = default;
    ZcrExtendedTextInputV1Shim(ZcrExtendedTextInputV1Shim&&) = delete;
    ZcrExtendedTextInputV1Shim& operator=(ZcrExtendedTextInputV1Shim&&) = delete;
    virtual ~ZcrExtendedTextInputV1Shim() = default;

    virtual void set_user_data(struct zcr_extended_text_input_v1* zcr_extended_text_input_v1, void* user_data);

    virtual void* get_user_data(struct zcr_extended_text_input_v1* zcr_extended_text_input_v1);
    virtual int add_listener(struct zcr_extended_text_input_v1* zcr_extended_text_input_v1, const struct zcr_extended_text_input_v1_listener* listener, void* data);
    
    virtual void destroy(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1);
    
    virtual void deprecated_set_input_type(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
        uint32_t input_type,
        uint32_t input_mode,
        uint32_t input_flags,
        uint32_t learning_mode);
    
    virtual void set_grammar_fragment_at_cursor(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
        uint32_t start,
        uint32_t end,
        const char * suggestion);
    
    virtual void set_autocorrect_info(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
        uint32_t start,
        uint32_t end,
        uint32_t x,
        uint32_t y,
        uint32_t width,
        uint32_t height);
    
    virtual void finalize_virtual_keyboard_changes(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1);
    
    virtual void set_focus_reason(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
        uint32_t reason);
    
    virtual void set_input_type(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
        uint32_t input_type,
        uint32_t input_mode,
        uint32_t input_flags,
        uint32_t learning_mode,
        uint32_t inline_composition_support);
    
    virtual void set_surrounding_text_support(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
        uint32_t support);
    
    virtual void set_surrounding_text_offset_utf16(
        struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
        uint32_t offset_utf16);
    
    virtual void send_set_preedit_region(
        struct wl_resource* resource,
        int32_t index,
        uint32_t length);
    
    virtual void send_clear_grammar_fragments(
        struct wl_resource* resource,
        uint32_t start,
        uint32_t end);
    
    virtual void send_add_grammar_fragment(
        struct wl_resource* resource,
        uint32_t start,
        uint32_t end,
        const char * suggestion);
    
    virtual void send_set_autocorrect_range(
        struct wl_resource* resource,
        uint32_t start,
        uint32_t end);
    
    virtual void send_set_virtual_keyboard_occluded_bounds(
        struct wl_resource* resource,
        int32_t x,
        int32_t y,
        int32_t width,
        int32_t height);
    
    virtual void send_confirm_preedit(
        struct wl_resource* resource,
        uint32_t selection_behavior);
    };

ZcrExtendedTextInputV1Shim* zcr_extended_text_input_v1_shim();
void set_zcr_extended_text_input_v1_shim (ZcrExtendedTextInputV1Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_TEXT_INPUT_EXTENSION_UNSTABLE_V1_SHIM_H_