// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_TEXT_INPUT_UNSTABLE_V1_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_TEXT_INPUT_UNSTABLE_V1_SHIM_H_

#include "text-input-unstable-v1-client-protocol.h"  // NOLINT(build/include_directory)
#include "text-input-unstable-v1-server-protocol.h"  // NOLINT(build/include_directory)


class ZwpTextInputV1Shim {
  public:
    ZwpTextInputV1Shim() = default;
    ZwpTextInputV1Shim(ZwpTextInputV1Shim&&) = delete;
    ZwpTextInputV1Shim& operator=(ZwpTextInputV1Shim&&) = delete;
    virtual ~ZwpTextInputV1Shim() = default;

    virtual void set_user_data(struct zwp_text_input_v1* zwp_text_input_v1, void* user_data);

    virtual void* get_user_data(struct zwp_text_input_v1* zwp_text_input_v1);
    virtual int add_listener(struct zwp_text_input_v1* zwp_text_input_v1, const struct zwp_text_input_v1_listener* listener, void* data);
    
    virtual void activate(
        struct zwp_text_input_v1 *zwp_text_input_v1,
        struct wl_seat* seat,
        struct wl_surface* surface);
    
    virtual void deactivate(
        struct zwp_text_input_v1 *zwp_text_input_v1,
        struct wl_seat* seat);
    
    virtual void show_input_panel(
        struct zwp_text_input_v1 *zwp_text_input_v1);
    
    virtual void hide_input_panel(
        struct zwp_text_input_v1 *zwp_text_input_v1);
    
    virtual void reset(
        struct zwp_text_input_v1 *zwp_text_input_v1);
    
    virtual void set_surrounding_text(
        struct zwp_text_input_v1 *zwp_text_input_v1,
        const char * text,
        uint32_t cursor,
        uint32_t anchor);
    
    virtual void set_content_type(
        struct zwp_text_input_v1 *zwp_text_input_v1,
        uint32_t hint,
        uint32_t purpose);
    
    virtual void set_cursor_rectangle(
        struct zwp_text_input_v1 *zwp_text_input_v1,
        int32_t x,
        int32_t y,
        int32_t width,
        int32_t height);
    
    virtual void set_preferred_language(
        struct zwp_text_input_v1 *zwp_text_input_v1,
        const char * language);
    
    virtual void commit_state(
        struct zwp_text_input_v1 *zwp_text_input_v1,
        uint32_t serial);
    
    virtual void invoke_action(
        struct zwp_text_input_v1 *zwp_text_input_v1,
        uint32_t button,
        uint32_t index);
    
    virtual void send_enter(
        struct wl_resource* resource,
        struct wl_resource * surface);
    
    virtual void send_leave(
        struct wl_resource* resource);
    
    virtual void send_modifiers_map(
        struct wl_resource* resource,
        struct wl_array* map);
    
    virtual void send_input_panel_state(
        struct wl_resource* resource,
        uint32_t state);
    
    virtual void send_preedit_string(
        struct wl_resource* resource,
        uint32_t serial,
        const char * text,
        const char * commit);
    
    virtual void send_preedit_styling(
        struct wl_resource* resource,
        uint32_t index,
        uint32_t length,
        uint32_t style);
    
    virtual void send_preedit_cursor(
        struct wl_resource* resource,
        int32_t index);
    
    virtual void send_commit_string(
        struct wl_resource* resource,
        uint32_t serial,
        const char * text);
    
    virtual void send_cursor_position(
        struct wl_resource* resource,
        int32_t index,
        int32_t anchor);
    
    virtual void send_delete_surrounding_text(
        struct wl_resource* resource,
        int32_t index,
        uint32_t length);
    
    virtual void send_keysym(
        struct wl_resource* resource,
        uint32_t serial,
        uint32_t time,
        uint32_t sym,
        uint32_t state,
        uint32_t modifiers);
    
    virtual void send_language(
        struct wl_resource* resource,
        uint32_t serial,
        const char * language);
    
    virtual void send_text_direction(
        struct wl_resource* resource,
        uint32_t serial,
        uint32_t direction);
    };

ZwpTextInputV1Shim* zwp_text_input_v1_shim();
void set_zwp_text_input_v1_shim (ZwpTextInputV1Shim* shim);

class ZwpTextInputManagerV1Shim {
  public:
    ZwpTextInputManagerV1Shim() = default;
    ZwpTextInputManagerV1Shim(ZwpTextInputManagerV1Shim&&) = delete;
    ZwpTextInputManagerV1Shim& operator=(ZwpTextInputManagerV1Shim&&) = delete;
    virtual ~ZwpTextInputManagerV1Shim() = default;

    virtual void set_user_data(struct zwp_text_input_manager_v1* zwp_text_input_manager_v1, void* user_data);

    virtual void* get_user_data(struct zwp_text_input_manager_v1* zwp_text_input_manager_v1);
    virtual struct zwp_text_input_v1* create_text_input(
        struct zwp_text_input_manager_v1 *zwp_text_input_manager_v1);
    };

ZwpTextInputManagerV1Shim* zwp_text_input_manager_v1_shim();
void set_zwp_text_input_manager_v1_shim (ZwpTextInputManagerV1Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_TEXT_INPUT_UNSTABLE_V1_SHIM_H_