/* Generated by wayland-scanner 1.22.0 */

#ifndef TEXT_INPUT_X11_UNSTABLE_V1_CLIENT_PROTOCOL_H
#define TEXT_INPUT_X11_UNSTABLE_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_text_input_x11_unstable_v1 The text_input_x11_unstable_v1 protocol
 * @section page_ifaces_text_input_x11_unstable_v1 Interfaces
 * - @subpage page_iface_zcr_text_input_x11_v1 - Extension support for using text_input with X11 apps
 * @section page_copyright_text_input_x11_unstable_v1 Copyright
 * <pre>
 *
 * Copyright 2022 The ChromiumOS Authors
 * Use of this source code is governed by a BSD-style license that can be
 * found in the LICENSE file.
 * </pre>
 */
struct wl_seat;
struct zcr_text_input_x11_v1;
struct zwp_text_input_v1;

#ifndef ZCR_TEXT_INPUT_X11_V1_INTERFACE
#define ZCR_TEXT_INPUT_X11_V1_INTERFACE
/**
 * @page page_iface_zcr_text_input_x11_v1 zcr_text_input_x11_v1
 * @section page_iface_zcr_text_input_x11_v1_desc Description
 *
 * Adds functionality for X11 apps running on Xwayland to connect to the
 * Wayland compositor and receive text_input support.
 * @section page_iface_zcr_text_input_x11_v1_api API
 * See @ref iface_zcr_text_input_x11_v1.
 */
/**
 * @defgroup iface_zcr_text_input_x11_v1 The zcr_text_input_x11_v1 interface
 *
 * Adds functionality for X11 apps running on Xwayland to connect to the
 * Wayland compositor and receive text_input support.
 */
extern const struct wl_interface zcr_text_input_x11_v1_interface;
#endif

#define ZCR_TEXT_INPUT_X11_V1_ACTIVATE 0


/**
 * @ingroup iface_zcr_text_input_x11_v1
 */
#define ZCR_TEXT_INPUT_X11_V1_ACTIVATE_SINCE_VERSION 1

/** @ingroup iface_zcr_text_input_x11_v1 */
static inline void
zcr_text_input_x11_v1_set_user_data(struct zcr_text_input_x11_v1 *zcr_text_input_x11_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zcr_text_input_x11_v1, user_data);
}

/** @ingroup iface_zcr_text_input_x11_v1 */
static inline void *
zcr_text_input_x11_v1_get_user_data(struct zcr_text_input_x11_v1 *zcr_text_input_x11_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zcr_text_input_x11_v1);
}

static inline uint32_t
zcr_text_input_x11_v1_get_version(struct zcr_text_input_x11_v1 *zcr_text_input_x11_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zcr_text_input_x11_v1);
}

/** @ingroup iface_zcr_text_input_x11_v1 */
static inline void
zcr_text_input_x11_v1_destroy(struct zcr_text_input_x11_v1 *zcr_text_input_x11_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zcr_text_input_x11_v1);
}

/**
 * @ingroup iface_zcr_text_input_x11_v1
 *
 * Calls text_input::activate with the X11 window id converted to the
 * matching wl_surface.
 */
static inline void
zcr_text_input_x11_v1_activate(struct zcr_text_input_x11_v1 *zcr_text_input_x11_v1, struct zwp_text_input_v1 *text_input, struct wl_seat *seat, uint32_t x11_window_id)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_text_input_x11_v1,
			 ZCR_TEXT_INPUT_X11_V1_ACTIVATE, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_text_input_x11_v1), 0, text_input, seat, x11_window_id);
}

#ifdef  __cplusplus
}
#endif

#endif
