// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#ifndef VM_TOOLS_SOMMELIER_GEN_XDG_OUTPUT_UNSTABLE_V1_SHIM_H_
#define VM_TOOLS_SOMMELIER_GEN_XDG_OUTPUT_UNSTABLE_V1_SHIM_H_

#include "xdg-output-unstable-v1-client-protocol.h"  // NOLINT(build/include_directory)
#include "xdg-output-unstable-v1-server-protocol.h"  // NOLINT(build/include_directory)


class ZxdgOutputManagerV1Shim {
  public:
    ZxdgOutputManagerV1Shim() = default;
    ZxdgOutputManagerV1Shim(ZxdgOutputManagerV1Shim&&) = delete;
    ZxdgOutputManagerV1Shim& operator=(ZxdgOutputManagerV1Shim&&) = delete;
    virtual ~ZxdgOutputManagerV1Shim() = default;

    virtual void set_user_data(struct zxdg_output_manager_v1* zxdg_output_manager_v1, void* user_data);

    virtual void* get_user_data(struct zxdg_output_manager_v1* zxdg_output_manager_v1);
    virtual void destroy(
        struct zxdg_output_manager_v1 *zxdg_output_manager_v1);
    
    virtual struct zxdg_output_v1* get_xdg_output(
        struct zxdg_output_manager_v1 *zxdg_output_manager_v1,
        struct wl_output* output);
    };

ZxdgOutputManagerV1Shim* zxdg_output_manager_v1_shim();
void set_zxdg_output_manager_v1_shim (ZxdgOutputManagerV1Shim* shim);

class ZxdgOutputV1Shim {
  public:
    ZxdgOutputV1Shim() = default;
    ZxdgOutputV1Shim(ZxdgOutputV1Shim&&) = delete;
    ZxdgOutputV1Shim& operator=(ZxdgOutputV1Shim&&) = delete;
    virtual ~ZxdgOutputV1Shim() = default;

    virtual void set_user_data(struct zxdg_output_v1* zxdg_output_v1, void* user_data);

    virtual void* get_user_data(struct zxdg_output_v1* zxdg_output_v1);
    virtual int add_listener(struct zxdg_output_v1* zxdg_output_v1, const struct zxdg_output_v1_listener* listener, void* data);
    
    virtual void destroy(
        struct zxdg_output_v1 *zxdg_output_v1);
    
    virtual void send_logical_position(
        struct wl_resource* resource,
        int32_t x,
        int32_t y);
    
    virtual void send_logical_size(
        struct wl_resource* resource,
        int32_t width,
        int32_t height);
    
    virtual void send_done(
        struct wl_resource* resource);
    
    virtual void send_name(
        struct wl_resource* resource,
        const char * name);
    
    virtual void send_description(
        struct wl_resource* resource,
        const char * description);
    };

ZxdgOutputV1Shim* zxdg_output_v1_shim();
void set_zxdg_output_v1_shim (ZxdgOutputV1Shim* shim);

 
#endif // VM_TOOLS_SOMMELIER_GEN_XDG_OUTPUT_UNSTABLE_V1_SHIM_H_