// Copyright 2023 The ChromiumOS Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// NOTE: This code is automatically generated and  any changes to this file will be overwritten.

#include "xdg-shell-shim.h"

void XdgWmBaseShim::set_user_data(struct xdg_wm_base *xdg_wm_base, void* user_data) {
  xdg_wm_base_set_user_data(xdg_wm_base, user_data);
}

void* XdgWmBaseShim::get_user_data(struct xdg_wm_base *xdg_wm_base) {
  return xdg_wm_base_get_user_data(xdg_wm_base);
}
int XdgWmBaseShim::add_listener(struct xdg_wm_base* xdg_wm_base, const struct xdg_wm_base_listener* listener, void* data) {
  return xdg_wm_base_add_listener(xdg_wm_base, listener, data);
}

void XdgWmBaseShim::destroy(
    struct xdg_wm_base *xdg_wm_base) {
  return xdg_wm_base_destroy(xdg_wm_base);
}

struct xdg_positioner* XdgWmBaseShim::create_positioner(
    struct xdg_wm_base *xdg_wm_base) {
  return xdg_wm_base_create_positioner(xdg_wm_base);
}

struct xdg_surface* XdgWmBaseShim::get_xdg_surface(
    struct xdg_wm_base *xdg_wm_base,
    struct wl_surface* surface) {
  return xdg_wm_base_get_xdg_surface(xdg_wm_base, surface);
}

void XdgWmBaseShim::pong(
    struct xdg_wm_base *xdg_wm_base,
    uint32_t serial) {
  return xdg_wm_base_pong(xdg_wm_base, serial);
}

void XdgWmBaseShim::send_ping(
    struct wl_resource* resource,
    uint32_t serial) {
  xdg_wm_base_send_ping(resource, serial);
}
static XdgWmBaseShim* xdg_wm_base_singleton = nullptr;

XdgWmBaseShim* xdg_wm_base_shim() {
  return xdg_wm_base_singleton;
}

void set_xdg_wm_base_shim (XdgWmBaseShim* shim) {
  xdg_wm_base_singleton = shim;
}


void XdgPositionerShim::set_user_data(struct xdg_positioner *xdg_positioner, void* user_data) {
  xdg_positioner_set_user_data(xdg_positioner, user_data);
}

void* XdgPositionerShim::get_user_data(struct xdg_positioner *xdg_positioner) {
  return xdg_positioner_get_user_data(xdg_positioner);
}
void XdgPositionerShim::destroy(
    struct xdg_positioner *xdg_positioner) {
  return xdg_positioner_destroy(xdg_positioner);
}

void XdgPositionerShim::set_size(
    struct xdg_positioner *xdg_positioner,
    int32_t width,
    int32_t height) {
  return xdg_positioner_set_size(xdg_positioner, width, height);
}

void XdgPositionerShim::set_anchor_rect(
    struct xdg_positioner *xdg_positioner,
    int32_t x,
    int32_t y,
    int32_t width,
    int32_t height) {
  return xdg_positioner_set_anchor_rect(xdg_positioner, x, y, width, height);
}

void XdgPositionerShim::set_anchor(
    struct xdg_positioner *xdg_positioner,
    uint32_t anchor) {
  return xdg_positioner_set_anchor(xdg_positioner, anchor);
}

void XdgPositionerShim::set_gravity(
    struct xdg_positioner *xdg_positioner,
    uint32_t gravity) {
  return xdg_positioner_set_gravity(xdg_positioner, gravity);
}

void XdgPositionerShim::set_constraint_adjustment(
    struct xdg_positioner *xdg_positioner,
    uint32_t constraint_adjustment) {
  return xdg_positioner_set_constraint_adjustment(xdg_positioner, constraint_adjustment);
}

void XdgPositionerShim::set_offset(
    struct xdg_positioner *xdg_positioner,
    int32_t x,
    int32_t y) {
  return xdg_positioner_set_offset(xdg_positioner, x, y);
}

void XdgPositionerShim::set_reactive(
    struct xdg_positioner *xdg_positioner) {
  return xdg_positioner_set_reactive(xdg_positioner);
}

void XdgPositionerShim::set_parent_size(
    struct xdg_positioner *xdg_positioner,
    int32_t parent_width,
    int32_t parent_height) {
  return xdg_positioner_set_parent_size(xdg_positioner, parent_width, parent_height);
}

void XdgPositionerShim::set_parent_configure(
    struct xdg_positioner *xdg_positioner,
    uint32_t serial) {
  return xdg_positioner_set_parent_configure(xdg_positioner, serial);
}
static XdgPositionerShim* xdg_positioner_singleton = nullptr;

XdgPositionerShim* xdg_positioner_shim() {
  return xdg_positioner_singleton;
}

void set_xdg_positioner_shim (XdgPositionerShim* shim) {
  xdg_positioner_singleton = shim;
}


void XdgSurfaceShim::set_user_data(struct xdg_surface *xdg_surface, void* user_data) {
  xdg_surface_set_user_data(xdg_surface, user_data);
}

void* XdgSurfaceShim::get_user_data(struct xdg_surface *xdg_surface) {
  return xdg_surface_get_user_data(xdg_surface);
}
int XdgSurfaceShim::add_listener(struct xdg_surface* xdg_surface, const struct xdg_surface_listener* listener, void* data) {
  return xdg_surface_add_listener(xdg_surface, listener, data);
}

void XdgSurfaceShim::destroy(
    struct xdg_surface *xdg_surface) {
  return xdg_surface_destroy(xdg_surface);
}

struct xdg_toplevel* XdgSurfaceShim::get_toplevel(
    struct xdg_surface *xdg_surface) {
  return xdg_surface_get_toplevel(xdg_surface);
}

struct xdg_popup* XdgSurfaceShim::get_popup(
    struct xdg_surface *xdg_surface,
    struct xdg_surface* parent,
    struct xdg_positioner* positioner) {
  return xdg_surface_get_popup(xdg_surface, parent, positioner);
}

void XdgSurfaceShim::set_window_geometry(
    struct xdg_surface *xdg_surface,
    int32_t x,
    int32_t y,
    int32_t width,
    int32_t height) {
  return xdg_surface_set_window_geometry(xdg_surface, x, y, width, height);
}

void XdgSurfaceShim::ack_configure(
    struct xdg_surface *xdg_surface,
    uint32_t serial) {
  return xdg_surface_ack_configure(xdg_surface, serial);
}

void XdgSurfaceShim::send_configure(
    struct wl_resource* resource,
    uint32_t serial) {
  xdg_surface_send_configure(resource, serial);
}
static XdgSurfaceShim* xdg_surface_singleton = nullptr;

XdgSurfaceShim* xdg_surface_shim() {
  return xdg_surface_singleton;
}

void set_xdg_surface_shim (XdgSurfaceShim* shim) {
  xdg_surface_singleton = shim;
}


void XdgToplevelShim::set_user_data(struct xdg_toplevel *xdg_toplevel, void* user_data) {
  xdg_toplevel_set_user_data(xdg_toplevel, user_data);
}

void* XdgToplevelShim::get_user_data(struct xdg_toplevel *xdg_toplevel) {
  return xdg_toplevel_get_user_data(xdg_toplevel);
}
int XdgToplevelShim::add_listener(struct xdg_toplevel* xdg_toplevel, const struct xdg_toplevel_listener* listener, void* data) {
  return xdg_toplevel_add_listener(xdg_toplevel, listener, data);
}

void XdgToplevelShim::destroy(
    struct xdg_toplevel *xdg_toplevel) {
  return xdg_toplevel_destroy(xdg_toplevel);
}

void XdgToplevelShim::set_parent(
    struct xdg_toplevel *xdg_toplevel,
    struct xdg_toplevel* parent) {
  return xdg_toplevel_set_parent(xdg_toplevel, parent);
}

void XdgToplevelShim::set_title(
    struct xdg_toplevel *xdg_toplevel,
    const char * title) {
  return xdg_toplevel_set_title(xdg_toplevel, title);
}

void XdgToplevelShim::set_app_id(
    struct xdg_toplevel *xdg_toplevel,
    const char * app_id) {
  return xdg_toplevel_set_app_id(xdg_toplevel, app_id);
}

void XdgToplevelShim::show_window_menu(
    struct xdg_toplevel *xdg_toplevel,
    struct wl_seat* seat,
    uint32_t serial,
    int32_t x,
    int32_t y) {
  return xdg_toplevel_show_window_menu(xdg_toplevel, seat, serial, x, y);
}

void XdgToplevelShim::move(
    struct xdg_toplevel *xdg_toplevel,
    struct wl_seat* seat,
    uint32_t serial) {
  return xdg_toplevel_move(xdg_toplevel, seat, serial);
}

void XdgToplevelShim::resize(
    struct xdg_toplevel *xdg_toplevel,
    struct wl_seat* seat,
    uint32_t serial,
    uint32_t edges) {
  return xdg_toplevel_resize(xdg_toplevel, seat, serial, edges);
}

void XdgToplevelShim::set_max_size(
    struct xdg_toplevel *xdg_toplevel,
    int32_t width,
    int32_t height) {
  return xdg_toplevel_set_max_size(xdg_toplevel, width, height);
}

void XdgToplevelShim::set_min_size(
    struct xdg_toplevel *xdg_toplevel,
    int32_t width,
    int32_t height) {
  return xdg_toplevel_set_min_size(xdg_toplevel, width, height);
}

void XdgToplevelShim::set_maximized(
    struct xdg_toplevel *xdg_toplevel) {
  return xdg_toplevel_set_maximized(xdg_toplevel);
}

void XdgToplevelShim::unset_maximized(
    struct xdg_toplevel *xdg_toplevel) {
  return xdg_toplevel_unset_maximized(xdg_toplevel);
}

void XdgToplevelShim::set_fullscreen(
    struct xdg_toplevel *xdg_toplevel,
    struct wl_output* output) {
  return xdg_toplevel_set_fullscreen(xdg_toplevel, output);
}

void XdgToplevelShim::unset_fullscreen(
    struct xdg_toplevel *xdg_toplevel) {
  return xdg_toplevel_unset_fullscreen(xdg_toplevel);
}

void XdgToplevelShim::set_minimized(
    struct xdg_toplevel *xdg_toplevel) {
  return xdg_toplevel_set_minimized(xdg_toplevel);
}

void XdgToplevelShim::send_configure(
    struct wl_resource* resource,
    int32_t width,
    int32_t height,
    struct wl_array* states) {
  xdg_toplevel_send_configure(resource, width, height, states);
}

void XdgToplevelShim::send_close(
    struct wl_resource* resource) {
  xdg_toplevel_send_close(resource);
}
static XdgToplevelShim* xdg_toplevel_singleton = nullptr;

XdgToplevelShim* xdg_toplevel_shim() {
  return xdg_toplevel_singleton;
}

void set_xdg_toplevel_shim (XdgToplevelShim* shim) {
  xdg_toplevel_singleton = shim;
}


void XdgPopupShim::set_user_data(struct xdg_popup *xdg_popup, void* user_data) {
  xdg_popup_set_user_data(xdg_popup, user_data);
}

void* XdgPopupShim::get_user_data(struct xdg_popup *xdg_popup) {
  return xdg_popup_get_user_data(xdg_popup);
}
int XdgPopupShim::add_listener(struct xdg_popup* xdg_popup, const struct xdg_popup_listener* listener, void* data) {
  return xdg_popup_add_listener(xdg_popup, listener, data);
}

void XdgPopupShim::destroy(
    struct xdg_popup *xdg_popup) {
  return xdg_popup_destroy(xdg_popup);
}

void XdgPopupShim::grab(
    struct xdg_popup *xdg_popup,
    struct wl_seat* seat,
    uint32_t serial) {
  return xdg_popup_grab(xdg_popup, seat, serial);
}

void XdgPopupShim::reposition(
    struct xdg_popup *xdg_popup,
    struct xdg_positioner* positioner,
    uint32_t token) {
  return xdg_popup_reposition(xdg_popup, positioner, token);
}

void XdgPopupShim::send_configure(
    struct wl_resource* resource,
    int32_t x,
    int32_t y,
    int32_t width,
    int32_t height) {
  xdg_popup_send_configure(resource, x, y, width, height);
}

void XdgPopupShim::send_popup_done(
    struct wl_resource* resource) {
  xdg_popup_send_popup_done(resource);
}

void XdgPopupShim::send_repositioned(
    struct wl_resource* resource,
    uint32_t token) {
  xdg_popup_send_repositioned(resource, token);
}
static XdgPopupShim* xdg_popup_singleton = nullptr;

XdgPopupShim* xdg_popup_shim() {
  return xdg_popup_singleton;
}

void set_xdg_popup_shim (XdgPopupShim* shim) {
  xdg_popup_singleton = shim;
}
